SystemOrganization addCategory: #'Tweak-OpenGL'!

CPanel subclass: #Wrinkle1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-OpenGL'!

!Wrinkle1 commentStamp: 'daf 7/15/2007 08:30' prior: 0!
A Procedural Texturing app using GLSL and Tweak!

Wrinkle1 defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="scaleScroller" toSet="scaleScroller:" changeEvent="scaleScrollerChanged">scaleScroller</field>
	<field toGet="col1Button" toSet="col1Button:" changeEvent="col1ButtonChanged">col1Button</field>
	<field toGet="col2Button" toSet="col2Button:" changeEvent="col2ButtonChanged">col2Button</field>
	<field toGet="saveButton" toSet="saveButton:" changeEvent="saveButtonChanged">saveButton</field>
	<field toGet="quitButton" toSet="quitButton:" changeEvent="quitButtonChanged">quitButton</field>
	<field toGet="oglPlayer" toSet="oglPlayer:" changeEvent="oglPlayerChanged">oglPlayer</field>
	<field toGet="scaleLabel" toSet="scaleLabel:" changeEvent="scaleLabelChanged">scaleLabel</field>
	<field toGet="rotScroller" toSet="rotScroller:" changeEvent="rotScrollerChanged">rotScroller</field>
	<field toGet="rotLabel" toSet="rotLabel:" changeEvent="rotLabelChanged">rotLabel</field>
	<field toGet="fragList" toSet="fragList:" changeEvent="fragListChanged">fragList</field>
	<field toGet="fragLabel" toSet="fragLabel:" changeEvent="fragLabelChanged">fragLabel</field>
</fields>'!

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 7/2/2007 19:20'!
col1Button
	"Answer the col1Button of the receiver"
	<bewareOf: #col1ButtonChanged>
	^self propertyValueAt: #col1Button! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 7/2/2007 19:20'!
col1Button: aValue
	"Modify the receiver's col1Button"
	^self propertyValueAt: #col1Button put: aValue with: #col1ButtonChanged! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 7/2/2007 19:20'!
col2Button
	"Answer the col2Button of the receiver"
	<bewareOf: #col2ButtonChanged>
	^self propertyValueAt: #col2Button! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 7/2/2007 19:20'!
col2Button: aValue
	"Modify the receiver's col2Button"
	^self propertyValueAt: #col2Button put: aValue with: #col2ButtonChanged! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 7/21/2007 11:01'!
fragLabel
	"Answer the fragLabel of the receiver"
	<bewareOf: #fragLabelChanged>
	^self propertyValueAt: #fragLabel! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 7/21/2007 11:01'!
fragLabel: aValue
	"Modify the receiver's fragLabel"
	^self propertyValueAt: #fragLabel put: aValue with: #fragLabelChanged! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 7/21/2007 11:00'!
fragList
	"Answer the fragList of the receiver"
	<bewareOf: #fragListChanged>
	^self propertyValueAt: #fragList! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 7/21/2007 11:01'!
fragList: aValue
	"Modify the receiver's fragList"
	^self propertyValueAt: #fragList put: aValue with: #fragListChanged! !

!Wrinkle1 methodsFor: 'initialize' stamp: 'daf 8/2/2007 20:55'!
initialize
	"initialize the wrinkle machine"
	| aHeight aWidth |
	super initialize.
	self define: #oglPlayer as: MyOGLPlayer5 new.

	aHeight := TextStyle default defaultFont pixelSize + 2.
	aWidth := (TextStyle default defaultFont widthOfString: 'fragShader') + 2.

	self define: #fragLabel as: CLabel new.
	fragLabel value: 'fragShader'; height: aHeight; width: aWidth.
	self define: #fragList as: CDropDownList new.
	oglPlayer selectors4Frags do: [ :ea |
		fragList add: (CListItem new value: ea).
	].

	self define: #scaleLabel as: CLabel new.
	scaleLabel value: 'scale'; height: aHeight; width: aWidth.
	self define: #scaleScroller as: CScrollBar new.
	scaleScroller min: 1.0.
	scaleScroller max: 100.0.

	self define: #rotLabel as: CLabel new.
	rotLabel value: 'rotate'; height: aHeight; width: aWidth.
	self define: #rotScroller as: CScrollBar new.
	rotScroller min: 0.0-(Float pi).
	rotScroller max: Float pi.

	self define: #col1Button as: CButton new.
	col1Button label: 'color 1'.

	self define: #col2Button as: CButton new.
	col2Button label: 'color2'.

	self define: #saveButton as: CButton new.
	saveButton label: 'save'.

	self define: #quitButton as: CButton new.
	quitButton label: 'quit'.
! !

!Wrinkle1 methodsFor: 'initialize' stamp: 'daf 6/23/2007 08:51'!
newRow
	| row |

	" Make a row. "
	row := CPlayer new.
	row layout: CTableLayout new.
	row layout cellInset: 1.
	row layout listDirection: #leftToRight.
	row layout listCentering: #topLeft.
	row layout listSpacing: #none.
	row layout cellSpacing: #none.
	row layoutInset: 1.
	row hResizing: #shrinkWrap.
	row vResizing: #shrinkWrap.

	^row! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 6/17/2007 12:23'!
oglPlayer
	"Answer the oglPlayer of the receiver"
	<bewareOf: #oglPlayerChanged>
	^self propertyValueAt: #oglPlayer! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 6/17/2007 12:23'!
oglPlayer: aValue
	"Modify the receiver's oglPlayer"
	^self propertyValueAt: #oglPlayer put: aValue with: #oglPlayerChanged! !

!Wrinkle1 methodsFor: 'events' stamp: 'daf 7/2/2007 23:56'!
onColor1Button
	| picker |
	<on: mouseDown in: col1Button>
	picker := CColorPicker new.
	picker floating := true.
	picker player := oglPlayer fieldNamed: #pickedColor1.
	picker openAt: (hand position) - (picker extent // 2).
"	picker openAt: (self localToGlobal: col1Button center) - (picker extent // 2)."
	picker pickColor.
! !

!Wrinkle1 methodsFor: 'events' stamp: 'daf 7/3/2007 00:03'!
onColor2Button
	| picker |
	<on: mouseDown in: col2Button>
	picker := CColorPicker new.
	picker floating := true.
	picker player := oglPlayer fieldNamed: #pickedColor2.
	picker openAt: (hand position) - (picker extent // 2).
"	picker openAt: (self localToGlobal: col1Button center) - (picker extent // 2)."
	picker pickColor.
! !

!Wrinkle1 methodsFor: 'events' stamp: 'daf 7/21/2007 11:18'!
onFragSelected
	<on: cursorChanged in: fragList>
	self oglPlayer selectFrag: fragList items selection value.
! !

!Wrinkle1 methodsFor: 'events' stamp: 'daf 7/13/2007 21:39'!
onOGLShaderr: anError
	| |
	<on: anOGLshaderr in: oglPlayer>
	"Transcript show: anError;cr."
	CDialog inform: anError.! !

!Wrinkle1 methodsFor: 'events' stamp: 'sn 3/2/2013 12:41'!
onQuitButton
	| |
	<on: mouseDown in: quitButton>
	self oglPlayer destroy.
	"self close."! !

!Wrinkle1 methodsFor: 'events' stamp: 'daf 7/3/2007 16:23'!
onRotScroll
	<on: valueChanged in: rotScroller>
	self oglPlayer rotFactor: rotScroller value asFloat.
! !

!Wrinkle1 methodsFor: 'events' stamp: 'daf 7/29/2007 09:18'!
onSaveButton
	| |
	<on: mouseDown in: saveButton>
! !

!Wrinkle1 methodsFor: 'events' stamp: 'daf 6/22/2007 21:00'!
onScaleScroll
	<on: valueChanged in: scaleScroller>
	self oglPlayer scaleFactor: scaleScroller value asFloat.
! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 7/29/2007 09:12'!
quitButton
	"Answer the quitButton of the receiver"
	<bewareOf: #quitButtonChanged>
	^self propertyValueAt: #quitButton! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 7/29/2007 09:12'!
quitButton: aValue
	"Modify the receiver's quitButton"
	^self propertyValueAt: #quitButton put: aValue with: #quitButtonChanged! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:19'!
rotLabel
	"Answer the rotLabel of the receiver"
	<bewareOf: #rotLabelChanged>
	^self propertyValueAt: #rotLabel! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:19'!
rotLabel: aValue
	"Modify the receiver's rotLabel"
	^self propertyValueAt: #rotLabel put: aValue with: #rotLabelChanged! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:18'!
rotScroller
	"Answer the rotScroller of the receiver"
	<bewareOf: #rotScrollerChanged>
	^self propertyValueAt: #rotScroller! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:18'!
rotScroller: aValue
	"Modify the receiver's rotScroller"
	^self propertyValueAt: #rotScroller put: aValue with: #rotScrollerChanged! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 7/29/2007 09:16'!
saveButton
	"Answer the saveButton of the receiver"
	<bewareOf: #saveButtonChanged>
	^self propertyValueAt: #saveButton! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 7/29/2007 09:16'!
saveButton: aValue
	"Modify the receiver's saveButton"
	^self propertyValueAt: #saveButton put: aValue with: #saveButtonChanged! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 6/23/2007 08:34'!
scaleLabel
	"Answer the scaleLabel of the receiver"
	<bewareOf: #scaleLabelChanged>
	^self propertyValueAt: #scaleLabel! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 6/23/2007 08:34'!
scaleLabel: aValue
	"Modify the receiver's scaleLabel"
	^self propertyValueAt: #scaleLabel put: aValue with: #scaleLabelChanged! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 6/22/2007 20:59'!
scaleScroller
	"Answer the scaleScroller of the receiver"
	<bewareOf: #scaleScrollerChanged>
	^self propertyValueAt: #scaleScroller! !

!Wrinkle1 methodsFor: 'accessing' stamp: 'daf 6/22/2007 20:59'!
scaleScroller: aValue
	"Modify the receiver's scaleScroller"
	^self propertyValueAt: #scaleScroller put: aValue with: #scaleScrollerChanged! !

!Wrinkle1 methodsFor: 'initialize' stamp: 'sn 3/2/2013 12:28'!
setupCostume
	"setup the wrinkle machine costume"
	| row |
	super setupCostume.
	self extent: 500@400.
	self layout: CTableLayout new.

	oglPlayer hResizing: #spaceFill; vResizing: #spaceFill.
	oglPlayer  target: self.
	self add: oglPlayer.
	

	row := self newRow.
	fragLabel hResizing: #rigid; vResizing: #rigid.
	fragList hResizing: #spaceFill; vResizing: #shrinkWrap.
	row add: fragLabel; add: fragList.
	self add: row.

	row := self newRow.
	scaleLabel hResizing: #rigid; vResizing: #rigid.
	scaleScroller hResizing: #spaceFill; vResizing: #rigid.
	row add: scaleLabel; add: scaleScroller.
	self add: row.

	row := self newRow.
	rotLabel hResizing: #rigid; vResizing: #rigid.
	rotScroller hResizing: #spaceFill; vResizing: #rigid.
	row add: rotLabel; add: rotScroller.
	self add: row.

	row := self newRow.
	col1Button hResizing: #spaceFill; vResizing: #rigid.
	col2Button hResizing: #spaceFill; vResizing: #rigid.
	row add: col1Button; add: col2Button.
	self add: row.

	row := self newRow.
	saveButton hResizing: #spaceFill; vResizing: #rigid.
	quitButton hResizing: #spaceFill; vResizing: #rigid.
	row add: saveButton; add: quitButton.
	self add: row.
! !

CPanel subclass: #Wrinkle2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-OpenGL'!

!Wrinkle2 commentStamp: '<historical>' prior: 0!
A more complex Procedural Texturing app using GLSL and Tweak!

Wrinkle2 defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="scaleScroller" toSet="scaleScroller:" changeEvent="scaleScrollerChanged">scaleScroller</field>
	<field toGet="col1Button" toSet="col1Button:" changeEvent="col1ButtonChanged">col1Button</field>
	<field toGet="col2Button" toSet="col2Button:" changeEvent="col2ButtonChanged">col2Button</field>
	<field toGet="saveButton" toSet="saveButton:" changeEvent="saveButtonChanged">saveButton</field>
	<field toGet="quitButton" toSet="quitButton:" changeEvent="quitButtonChanged">quitButton</field>
	<field toGet="oglPlayer" toSet="oglPlayer:" changeEvent="oglPlayerChanged">oglPlayer</field>
	<field toGet="scaleLabel" toSet="scaleLabel:" changeEvent="scaleLabelChanged">scaleLabel</field>
	<field toGet="rotScroller" toSet="rotScroller:" changeEvent="rotScrollerChanged">rotScroller</field>
	<field toGet="rotLabel" toSet="rotLabel:" changeEvent="rotLabelChanged">rotLabel</field>
	<field toGet="mixScroller" toSet="mixScroller:" changeEvent="mixScrollerChanged">mixScroller</field>
	<field toGet="mixLabel" toSet="mixLabel:" changeEvent="mixLabelChanged">mixLabel</field>
	<field toGet="fragList" toSet="fragList:" changeEvent="fragListChanged">fragList</field>
	<field toGet="fragLabel" toSet="fragLabel:" changeEvent="fragLabelChanged">fragLabel</field>
	<field toGet="selLabel" toSet="selLabel:" changeEvent="selLabelChanged">selLabel</field>
	<field toGet="selButton1" toSet="selButton1:" changeEvent="selButton1Changed">selButton1</field>
	<field toGet="selButton2" toSet="selButton2:" changeEvent="selButton2Changed">selButton2</field>
	<field toGet="currSel" toSet="currSel:" changeEvent="currSelChanged">currSel</field>
	<field toGet="lastImportDirectory" toSet="lastImportDirectory:" changeEvent="lastImportDirectoryChanged">lastImportDirectory</field>
</fields>'!

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
col1Button
	"Answer the col1Button of the receiver"
	<bewareOf: #col1ButtonChanged>
	^self propertyValueAt: #col1Button! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
col1Button: aValue
	"Modify the receiver's col1Button"
	^self propertyValueAt: #col1Button put: aValue with: #col1ButtonChanged! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
col2Button
	"Answer the col2Button of the receiver"
	<bewareOf: #col2ButtonChanged>
	^self propertyValueAt: #col2Button! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
col2Button: aValue
	"Modify the receiver's col2Button"
	^self propertyValueAt: #col2Button put: aValue with: #col2ButtonChanged! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/4/2007 09:52'!
currSel
	"Answer the currSel of the receiver"
	<bewareOf: #currSelChanged>
	^self propertyValueAt: #currSel! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/4/2007 09:52'!
currSel: aValue
	"Modify the receiver's currSel"
	^self propertyValueAt: #currSel put: aValue with: #currSelChanged! !

!Wrinkle2 methodsFor: 'events' stamp: 'daf 8/18/2007 10:32'!
doSave
	"get the texture and save it to a file"

	| aForm fileName file writer dialog aPath |
	aForm := oglPlayer savedForm.

	dialog := CFileSaveDialog new.
	dialog extent: (450@250).
	aPath := FileDirectory pathFromURI: 'Content/Textures/Procedurals'.
	(FileDirectory on: aPath) assureExistence.
	dialog directory: (lastImportDirectory ifNil:[FileDirectory on: aPath]).
	fileName := dialog openFile:  #(
		('PNG' ('*.png'))
		('JPG' ('*.jpg' '*.jpeg'))
		('GIF' ('*.gif'))
		('BMP' ('*.bmp'))
	) label: 'Save picture'.
	fileName ifNil:[^self].
	lastImportDirectory := dialog directory.
	file := FileStream newFileNamed: fileName.
	[file binary.
		(file name endsWith: '.png') ifTrue:[writer := PNGReadWriter].
		(file name endsWith: '.bmp') ifTrue:[writer := BMPReadWriter].
		(file name endsWith: '.gif') ifTrue:[writer := GIFReadWriter].
		(file name endsWith: '.jpg') ifTrue:[writer := JPEGReadWriter2].
	writer := writer on: file.
	writer nextPutImage: aForm] 
		ensure:[file close].
! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
fragLabel
	"Answer the fragLabel of the receiver"
	<bewareOf: #fragLabelChanged>
	^self propertyValueAt: #fragLabel! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
fragLabel: aValue
	"Modify the receiver's fragLabel"
	^self propertyValueAt: #fragLabel put: aValue with: #fragLabelChanged! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
fragList
	"Answer the fragList of the receiver"
	<bewareOf: #fragListChanged>
	^self propertyValueAt: #fragList! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
fragList: aValue
	"Modify the receiver's fragList"
	^self propertyValueAt: #fragList put: aValue with: #fragListChanged! !

!Wrinkle2 methodsFor: 'initialize' stamp: 'daf 8/19/2007 08:52'!
initialize
	"initialize the wrinkle machine"
	| aHeight aWidth |
	super initialize.
	self define: #oglPlayer as: MyOGLPlayer6 new.

	aHeight := TextStyle default defaultFont pixelSize + 2.
	aWidth := (TextStyle default defaultFont widthOfString: 'fragShader') + 2.

	self define: #selLabel as: CLabel new.
	selLabel value: 'select'; height: aHeight; width: aWidth.
	self define: #selButton1 as: CRadioButton new.
	selButton1 label: 'stack1'.
	self define: #selButton2 as: CRadioButton new.
	selButton2 label: 'stack2'.
	currSel := 1.

	self define: #mixLabel as: CLabel new.
	mixLabel value: 'mix'; height: aHeight; width: aWidth.
	self define: #mixScroller as: CScrollBar new.
	mixScroller min: 0.0.
	mixScroller max: 1.0.
	mixScroller step: (mixScroller range / 100.0).
	mixScroller pageStep: (mixScroller step * 10.0).

	self define: #fragLabel as: CLabel new.
	fragLabel value: 'fragShader'; height: aHeight; width: aWidth.
	self define: #fragList as: CList new.
	oglPlayer selectors4Frags do: [ :ea |
		fragList add: (CListItem new value: ea).
	].

	self define: #scaleLabel as: CLabel new.
	scaleLabel value: 'scale'; height: aHeight; width: aWidth.
	self define: #scaleScroller as: CScrollBar new.
	scaleScroller min: 1.0.
	scaleScroller max: 100.0.
	scaleScroller step: (scaleScroller range / 100.0).
	scaleScroller pageStep: (scaleScroller step * 10.0).

	self define: #rotLabel as: CLabel new.
	rotLabel value: 'rotate'; height: aHeight; width: aWidth.
	self define: #rotScroller as: CScrollBar new.
	rotScroller min: 0.0-(Float pi).
	rotScroller max: Float pi.
	rotScroller step: (rotScroller range / 100.0).
	rotScroller pageStep: (rotScroller step * 10.0).

	self define: #col1Button as: CButton new.
	col1Button label: 'color 1'.

	self define: #col2Button as: CButton new.
	col2Button label: 'color2'.

	self define: #saveButton as: CButton new.
	saveButton label: 'save'.

	self define: #quitButton as: CButton new.
	quitButton label: 'quit'.
! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/18/2007 10:31'!
lastImportDirectory
	"Answer the lastImportDirectory of the receiver"
	<bewareOf: #lastImportDirectoryChanged>
	^self propertyValueAt: #lastImportDirectory! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/18/2007 10:31'!
lastImportDirectory: aValue
	"Modify the receiver's lastImportDirectory"
	^self propertyValueAt: #lastImportDirectory put: aValue with: #lastImportDirectoryChanged! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/5/2007 09:20'!
mixLabel
	"Answer the mixLabel of the receiver"
	<bewareOf: #mixLabelChanged>
	^self propertyValueAt: #mixLabel! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/5/2007 09:20'!
mixLabel: aValue
	"Modify the receiver's mixLabel"
	^self propertyValueAt: #mixLabel put: aValue with: #mixLabelChanged! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/5/2007 09:20'!
mixScroller
	"Answer the mixScroller of the receiver"
	<bewareOf: #mixScrollerChanged>
	^self propertyValueAt: #mixScroller! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/5/2007 09:20'!
mixScroller: aValue
	"Modify the receiver's mixScroller"
	^self propertyValueAt: #mixScroller put: aValue with: #mixScrollerChanged! !

!Wrinkle2 methodsFor: 'initialize' stamp: 'daf 8/19/2007 08:36'!
newColumn
	| column |

	" Make a column. "
	column := CPlayer new.
	column layoutInset: 1.
	column hResizing: #spaceFill; vResizing: #spaceFill.
	column layout: CTableLayout new.
	column layout cellInset: 1.
	column layout listDirection: #topToBottom; listCentering: #topLeft.
	column layout listSpacing: #none; cellSpacing: #none.

	^column! !

!Wrinkle2 methodsFor: 'initialize' stamp: 'daf 8/19/2007 08:50'!
newRow
	| row |

	" Make a row. "
	row := CPlayer new.
	row layout: CTableLayout new.
	row layout cellInset: 1.
	row layout listDirection: #leftToRight.
	row layout listCentering: #topLeft.
	row layout listSpacing: #none.
	row layout cellSpacing: #none.
	row layoutInset: 1.
	row hResizing: #spaceFill.
	row vResizing: #shrinkWrap.

	^row! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
oglPlayer
	"Answer the oglPlayer of the receiver"
	<bewareOf: #oglPlayerChanged>
	^self propertyValueAt: #oglPlayer! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
oglPlayer: aValue
	"Modify the receiver's oglPlayer"
	^self propertyValueAt: #oglPlayer put: aValue with: #oglPlayerChanged! !

!Wrinkle2 methodsFor: 'events' stamp: 'daf 8/5/2007 17:09'!
onColor1Button
	| picker |
	<on: mouseDown in: col1Button>
	picker := CColorPicker new.
	picker floating := true.
	(currSel = 1) ifTrue: [ picker player := oglPlayer fieldNamed: #picked1Color1. ].
	(currSel = 2) ifTrue: [ picker player := oglPlayer fieldNamed: #picked2Color1. ].
	picker openAt: (hand position) - (picker extent // 2).
"	picker openAt: (self localToGlobal: col1Button center) - (picker extent // 2)."
	picker pickColor.
	(currSel = 1) ifTrue: [ col1Button color: oglPlayer col1Factor1 asVectorColor asColor. ].
	(currSel = 2) ifTrue: [ col1Button color: oglPlayer col1Factor2 asVectorColor asColor. ].
! !

!Wrinkle2 methodsFor: 'events' stamp: 'daf 8/5/2007 17:09'!
onColor2Button
	| picker |
	<on: mouseDown in: col2Button>
	picker := CColorPicker new.
	picker floating := true.
	(currSel = 1) ifTrue: [ picker player := oglPlayer fieldNamed: #picked1Color2. ].
	(currSel = 2) ifTrue: [ picker player := oglPlayer fieldNamed: #picked2Color2. ].
	picker openAt: (hand position) - (picker extent // 2).
"	picker openAt: (self localToGlobal: col1Button center) - (picker extent // 2)."
	picker pickColor.
	(currSel = 1) ifTrue: [ col2Button color: oglPlayer col2Factor1 asVectorColor asColor. ].
	(currSel = 2) ifTrue: [ col2Button color: oglPlayer col2Factor2 asVectorColor asColor. ].
! !

!Wrinkle2 methodsFor: 'events' stamp: 'daf 8/4/2007 10:02'!
onFragSelected
	<on: cursorChanged in: fragList>
	(currSel = 1) ifTrue: [ self oglPlayer select1Frag: fragList items selection value. ].
	(currSel = 2) ifTrue: [ self oglPlayer select2Frag: fragList items selection value. ].
! !

!Wrinkle2 methodsFor: 'events' stamp: 'daf 8/5/2007 09:25'!
onMixScroll
	<on: valueChanged in: mixScroller>
	(currSel = 1) ifTrue: [ self oglPlayer mix1Factor: mixScroller value asFloat. ].
	(currSel = 2) ifTrue: [ self oglPlayer mix2Factor: mixScroller value asFloat. ].
! !

!Wrinkle2 methodsFor: 'events' stamp: 'daf 8/2/2007 20:56'!
onOGLShaderr: anError
	| |
	<on: anOGLshaderr in: oglPlayer>
	"Transcript show: anError;cr."
	CDialog inform: anError.! !

!Wrinkle2 methodsFor: 'events' stamp: 'daf 8/18/2007 14:19'!
onOGLtex2form
	| |
	<on: anOGLtex2form in: oglPlayer>
	"save the form"
"	oglPlayer savedForm asPlayer open."
	self doSave.
! !

!Wrinkle2 methodsFor: 'events' stamp: 'sn 3/2/2013 12:41'!
onQuitButton
	| |
	<on: fire in: quitButton>
	self oglPlayer destroy.
	"self destroy."! !

!Wrinkle2 methodsFor: 'events' stamp: 'daf 8/4/2007 10:04'!
onRotScroll
	<on: valueChanged in: rotScroller>
	(currSel = 1) ifTrue: [ self oglPlayer rot1Factor: rotScroller value asFloat. ].
	(currSel = 2) ifTrue: [ self oglPlayer rot2Factor: rotScroller value asFloat. ].
! !

!Wrinkle2 methodsFor: 'events' stamp: 'daf 8/18/2007 09:42'!
onSaveButton
	| |
	<on: fire in: saveButton>
	"start the ball rolling.  when this flag is true, the oglPlayer will grab the texture into a Form, and then signal another event"
	self oglPlayer saveFlag: true.
! !

!Wrinkle2 methodsFor: 'events' stamp: 'daf 8/4/2007 10:05'!
onScaleScroll
	<on: valueChanged in: scaleScroller>
	(currSel = 1) ifTrue: [ self oglPlayer scale1Factor: scaleScroller value asFloat. ].
	(currSel = 2) ifTrue: [ self oglPlayer scale2Factor: scaleScroller value asFloat. ].

! !

!Wrinkle2 methodsFor: 'events' stamp: 'daf 8/5/2007 16:59'!
onSelButton1
	| |
	<on: fire in: selButton1>
	currSel := 1.
	mixScroller value: oglPlayer mix1Factor.
	scaleScroller value: oglPlayer scale1Factor.
	rotScroller value: oglPlayer rot1Factor.
	fragList items selection: oglPlayer curr1Frag.
	col1Button color: oglPlayer col1Factor1 asVectorColor asColor.
	col2Button color: oglPlayer col2Factor1 asVectorColor asColor.
! !

!Wrinkle2 methodsFor: 'events' stamp: 'daf 8/5/2007 16:59'!
onSelButton2
	| |
	<on: fire in: selButton2>
	currSel := 2.
	mixScroller value: oglPlayer mix2Factor.
	scaleScroller value: oglPlayer scale2Factor.
	rotScroller value: oglPlayer rot2Factor.
	fragList items selection: oglPlayer curr2Frag.
	col1Button color: oglPlayer col1Factor2 asVectorColor asColor.
	col2Button color: oglPlayer col2Factor2 asVectorColor asColor.
! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
quitButton
	"Answer the quitButton of the receiver"
	<bewareOf: #quitButtonChanged>
	^self propertyValueAt: #quitButton! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
quitButton: aValue
	"Modify the receiver's quitButton"
	^self propertyValueAt: #quitButton put: aValue with: #quitButtonChanged! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
rotLabel
	"Answer the rotLabel of the receiver"
	<bewareOf: #rotLabelChanged>
	^self propertyValueAt: #rotLabel! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
rotLabel: aValue
	"Modify the receiver's rotLabel"
	^self propertyValueAt: #rotLabel put: aValue with: #rotLabelChanged! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
rotScroller
	"Answer the rotScroller of the receiver"
	<bewareOf: #rotScrollerChanged>
	^self propertyValueAt: #rotScroller! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
rotScroller: aValue
	"Modify the receiver's rotScroller"
	^self propertyValueAt: #rotScroller put: aValue with: #rotScrollerChanged! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
saveButton
	"Answer the saveButton of the receiver"
	<bewareOf: #saveButtonChanged>
	^self propertyValueAt: #saveButton! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
saveButton: aValue
	"Modify the receiver's saveButton"
	^self propertyValueAt: #saveButton put: aValue with: #saveButtonChanged! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
scaleLabel
	"Answer the scaleLabel of the receiver"
	<bewareOf: #scaleLabelChanged>
	^self propertyValueAt: #scaleLabel! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
scaleLabel: aValue
	"Modify the receiver's scaleLabel"
	^self propertyValueAt: #scaleLabel put: aValue with: #scaleLabelChanged! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
scaleScroller
	"Answer the scaleScroller of the receiver"
	<bewareOf: #scaleScrollerChanged>
	^self propertyValueAt: #scaleScroller! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:56'!
scaleScroller: aValue
	"Modify the receiver's scaleScroller"
	^self propertyValueAt: #scaleScroller put: aValue with: #scaleScrollerChanged! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:59'!
selButton1
	"Answer the selButton1 of the receiver"
	<bewareOf: #selButton1Changed>
	^self propertyValueAt: #selButton1! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:59'!
selButton1: aValue
	"Modify the receiver's selButton1"
	^self propertyValueAt: #selButton1 put: aValue with: #selButton1Changed! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:59'!
selButton2
	"Answer the selButton2 of the receiver"
	<bewareOf: #selButton2Changed>
	^self propertyValueAt: #selButton2! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:59'!
selButton2: aValue
	"Modify the receiver's selButton2"
	^self propertyValueAt: #selButton2 put: aValue with: #selButton2Changed! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:59'!
selLabel
	"Answer the selLabel of the receiver"
	<bewareOf: #selLabelChanged>
	^self propertyValueAt: #selLabel! !

!Wrinkle2 methodsFor: 'accessing' stamp: 'daf 8/2/2007 20:59'!
selLabel: aValue
	"Modify the receiver's selLabel"
	^self propertyValueAt: #selLabel put: aValue with: #selLabelChanged! !

!Wrinkle2 methodsFor: 'initialize' stamp: 'sn 3/2/2013 12:28'!
setupCostume
	"setup the wrinkle machine costume"
	| row col1 col2 row1 |
	super setupCostume.
	self extent: 500@400.
	self layout: CTableLayout new.

	oglPlayer hResizing: #spaceFill; vResizing: #spaceFill.
	oglPlayer  target: self.
	self add: oglPlayer.

	row := self newRow.
	selLabel hResizing: #rigid; vResizing: #rigid.
	selButton1 hResizing: #spaceFill; vResizing: #shrinkWrap.
	selButton2 hResizing: #spaceFill; vResizing: #shrinkWrap.
	row add: selLabel; add: selButton1; add: selButton2.
	self add: row.

	selButton1 select.
	mixScroller value: oglPlayer mix1Factor.
	scaleScroller value: oglPlayer scale1Factor.
	rotScroller value: oglPlayer rot1Factor.
	fragList items selection: oglPlayer curr1Frag.
	col1Button color: oglPlayer col1Factor1 asVectorColor asColor.
	col2Button color: oglPlayer col2Factor1 asVectorColor asColor.

	row1 := self newRow.
	col1 := self newColumn.
	row := self newRow.
	mixLabel hResizing: #rigid; vResizing: #rigid.
	mixScroller hResizing: #spaceFill; vResizing: #rigid.
	row add: mixLabel; add: mixScroller.
	col1 add: row.

	col2 := self newColumn.
	fragLabel hResizing: #rigid; vResizing: #rigid.
	fragList hResizing: #spaceFill; vResizing: #spaceFill.
	col2 add: fragLabel; add: fragList.

	row := self newRow.
	scaleLabel hResizing: #rigid; vResizing: #rigid.
	scaleScroller hResizing: #spaceFill; vResizing: #rigid.
	row add: scaleLabel; add: scaleScroller.
	col1 add: row.

	row := self newRow.
	rotLabel hResizing: #rigid; vResizing: #rigid.
	rotScroller hResizing: #spaceFill; vResizing: #rigid.
	row add: rotLabel; add: rotScroller.
	col1 add: row.

	row := self newRow.
	col1Button hResizing: #spaceFill; vResizing: #rigid.
	col2Button hResizing: #spaceFill; vResizing: #rigid.
	row add: col1Button; add: col2Button.
	col1 add: row.

	row1 add: col1; add: col2.
	self add: row1.

	row := self newRow.
	saveButton hResizing: #spaceFill; vResizing: #rigid.
	quitButton hResizing: #spaceFill; vResizing: #rigid.
	row add: saveButton; add: quitButton.
	self add: row.
! !

CPanel subclass: #COpenGLPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants'
	category: 'Tweak-OpenGL'!

!COpenGLPanel commentStamp: '<historical>' prior: 0!
This is Andreas Raab's OpenGL panel for Tweak.
From Morphic try:
CProjectMorph open: COpenGLPanel.!

COpenGLPanel defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="ogl" toSet="ogl:" changeEvent="oglChanged">ogl</field>
</fields>'!

!COpenGLPanel methodsFor: 'initialize' stamp: 'ar 7/17/2007 09:33'!
destroy
        "Destroy ogl, too"
        ogl ifNotNil:[ogl destroy].
        super destroy.! !

!COpenGLPanel methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:26'!
ogl
	"Answer the ogl of the receiver"
	<bewareOf: #oglChanged>
	^self propertyValueAt: #ogl! !

!COpenGLPanel methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:26'!
ogl: aValue
	"Modify the receiver's ogl"
	^self propertyValueAt: #ogl put: aValue with: #oglChanged! !

!COpenGLPanel methodsFor: 'events' stamp: 'ar 7/17/2007 09:32'!
onStep
        | box |
        <ticking: 10>
        "FIXME: Set the current hand explicitly to the primary hand of this 
project since render may be signaled without an associated hand (via 
CProjectMorph>>step) which will cause problems later on when we try to refer 
to that (non-existing) hand"
        Processor activeProcess hand: Processor activeProject primaryHand.
        box := self globalBounds.
        box := box translateBy: (window boundsInWorld origin + window 
borderWidth).
        ogl ifNotNil:[ogl := ogl bufferRect: box].
        ogl ifNil:[ogl := OpenGL newIn: box].
        ogl ifNil:[^nil].
        ogl glClearColor: 1.0 with: 0.0 with: 0.0 with: 1.0.
        ogl glClear: GLColorBufferBit.
        ogl swapBuffers.
! !

COpenGLPanel subclass: #MyOGLPanel0
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-OpenGL'!

!MyOGLPanel0 commentStamp: '<historical>' prior: 0!
An alternate translation of the OpenGL NeHe tutorial 5 for Tweak.
From Morphic try:
CProjectMorph open: MyOGLPanel0.!

MyOGLPanel0 defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="phi" toSet="phi:" changeEvent="phiChanged">phi</field>
</fields>'!

!MyOGLPanel0 methodsFor: 'drawing' stamp: 'mtf 1/24/2011 14:12'!
glRenderOn: ogl

	| dx dy |
		dx := bounds width asFloat.
		dy := bounds height asFloat.

	ogl
		glClearColor: color red with: color green with: color blue with: 0.0;
		glClear: GLColorBufferBit+GLDepthBufferBit;
		initFrustum: 45.0 bounds: (0@0 extent: dx@dy) zNear: 0.1 zFar: 100.0;

	"This is translated from the NeHe Tutorials Lesson 5"
		glShadeModel: GLSmooth;		"Enables Smooth Shading"
		glClearDepth: 1.0;				"Depth Buffer Setup"
		glEnable: GLDepthTest;			"Enables Depth Testing"
		glDepthFunc: GLLequal;			"The Type Of Depth Test To Do"
		glHint: GLPerspectiveCorrectionHint with: GLNicest;	"Really Nice Perspective Calculations"

		glLoadIdentity;					"Reset The View"
		glTranslatef: -1.5 with: 0.0 with: -6.0;		"Move Left And Into The Screen"
		glRotatef: phi with: 0.0 with: 1.0 with: 0.0;		"Rotate The Pyramid On It's Y Axis"
		glBegin: GLTriangles;			"Start Drawing The Pyramid"

		glColor3f: 1.0 with: 0.0 with: 0.0;			"Red"
		glVertex3f:  0.0 with:  1.0 with:  0.0;		"Top Of Triangle (Front)"
		glColor3f: 0.0 with: 1.0 with: 0.0;			"Green"
		glVertex3f: -1.0 with: -1.0 with:  1.0;		"Left Of Triangle (Front)"
		glColor3f: 0.0 with: 0.0 with: 1.0;			"Blue"
		glVertex3f:  1.0 with: -1.0 with:  1.0;		"Right Of Triangle (Front)"

		glColor3f: 1.0 with: 0.0 with: 0.0;			"Red"
		glVertex3f:  0.0 with:  1.0 with:  0.0;		"Top Of Triangle (Right)"
		glColor3f: 0.0 with: 0.0 with: 1.0;			"Blue"
		glVertex3f:  1.0 with: -1.0 with:  1.0;		"Left Of Triangle (Right)"
		glColor3f: 0.0 with: 1.0 with: 0.0;			"Green"
		glVertex3f:  1.0 with: -1.0 with:  -1.0;		"Right Of Triangle (Right)"

		glColor3f: 1.0 with: 0.0 with: 0.0;			"Red"
		glVertex3f:  0.0 with:  1.0 with:  0.0;		"Top Of Triangle (Back)"
		glColor3f: 0.0 with: 1.0 with: 0.0;			"Green"
		glVertex3f:  1.0 with: -1.0 with:  -1.0;		"Left Of Triangle (Back)"
		glColor3f: 0.0 with: 0.0 with: 1.0;			"Blue"
		glVertex3f: -1.0 with: -1.0 with:  -1.0;		"Right Of Triangle (Back)"

		glColor3f: 1.0 with: 0.0 with: 0.0;			"Red"
		glVertex3f:  0.0 with:  1.0 with:  0.0;		"Top Of Triangle (Left)"
		glColor3f: 0.0 with: 0.0 with: 1.0;			"Blue"
		glVertex3f: -1.0 with: -1.0 with: -1.0;		"Left Of Triangle (Left)"
		glColor3f: 0.0 with: 1.0 with: 0.0;			"Green"
		glVertex3f: -1.0 with: -1.0 with:  1.0;		"Right Of Triangle (Left)"
		glEnd;							"Done Drawing The Pyramid"

		glLoadIdentity;
		glTranslatef: 1.5 with: 0.0 with: -7.0;		"Move Right And Into The Screen"
		glRotatef: phi with: 1.0 with: 1.0 with: 1.0;		"Rotate The Cube On X with:  Y & Z"
		glBegin: GLQuads;				"Start Drawing The Cube"

		glColor3f: 0.0 with: 1.0 with: 0.0;			"Set The Color To Green"
		glVertex3f:  1.0 with:  1.0 with: -1.0;		"Top Right Of The Quad (Top)"
		glVertex3f: -1.0 with:  1.0 with: -1.0;		"Top Left Of The Quad (Top)"
		glVertex3f: -1.0 with:  1.0 with:  1.0;		"Bottom Left Of The Quad (Top)"
		glVertex3f:  1.0 with:  1.0 with:  1.0;		"Bottom Right Of The Quad (Top)"

		glColor3f: 1.0 with: 0.5 with: 0.0;			"Set The Color To Orange"
		glVertex3f:  1.0 with: -1.0 with:  1.0;		"Top Right Of The Quad (Bottom)"
		glVertex3f: -1.0 with: -1.0 with:  1.0;		"Top Left Of The Quad (Bottom)"
		glVertex3f: -1.0 with: -1.0 with: -1.0;		"Bottom Left Of The Quad (Bottom)"
		glVertex3f:  1.0 with: -1.0 with: -1.0;		"Bottom Right Of The Quad (Bottom)"

		glColor3f: 1.0 with: 0.0 with: 0.0;			"Set The Color To Red"
		glVertex3f:  1.0 with:  1.0 with:  1.0;		"Top Right Of The Quad (Front)"
		glVertex3f: -1.0 with:  1.0 with:  1.0;		"Top Left Of The Quad (Front)"
		glVertex3f: -1.0 with: -1.0 with:  1.0;		"Bottom Left Of The Quad (Front)"
		glVertex3f:  1.0 with: -1.0 with:  1.0;		"Bottom Right Of The Quad (Front)"

		glColor3f: 1.0 with: 1.0 with: 0.0;			"Set The Color To Yellow"
		glVertex3f:  1.0 with: -1.0 with: -1.0;		"Bottom Left Of The Quad (Back)"
		glVertex3f: -1.0 with: -1.0 with: -1.0;		"Bottom Right Of The Quad (Back)"
		glVertex3f: -1.0 with:  1.0 with: -1.0;		"Top Right Of The Quad (Back)"
		glVertex3f:  1.0 with:  1.0 with: -1.0;		"Top Left Of The Quad (Back)"

		glColor3f: 0.0 with: 0.0 with: 1.0;			"Set The Color To Blue"
		glVertex3f: -1.0 with:  1.0 with:  1.0;		"Top Right Of The Quad (Left)"
		glVertex3f: -1.0 with:  1.0 with: -1.0;		"Top Left Of The Quad (Left)"
		glVertex3f: -1.0 with: -1.0 with: -1.0;		"Bottom Left Of The Quad (Left)"
		glVertex3f: -1.0 with: -1.0 with:  1.0;		"Bottom Right Of The Quad (Left)"

		glColor3f: 1.0 with: 0.0 with: 1.0;			"Set The Color To Violet"
		glVertex3f:  1.0 with:  1.0 with: -1.0;		"Top Right Of The Quad (Right)"
		glVertex3f:  1.0 with:  1.0 with:  1.0;		"Top Left Of The Quad (Right)"
		glVertex3f:  1.0 with: -1.0 with:  1.0;		"Bottom Left Of The Quad (Right)"
		glVertex3f:  1.0 with: -1.0 with: -1.0;		"Bottom Right Of The Quad (Right)"
		glEnd							"Done Drawing The Quad"
! !

!MyOGLPanel0 methodsFor: 'drawing' stamp: 'daf 8/6/2007 20:12'!
onStep
	| box |
	<ticking: 100>

	"FIXME: Set the current hand explicitly to the primary hand of this
	project since render may be signaled without an associated hand (via
	CProjectMorph>>step) which will cause problems later on when we try to refer
	to that (non-existing) hand"

	Processor activeProcess hand: Processor activeProject primaryHand.
	box := self globalBounds.
	box := box translateBy: (window boundsInWorld origin + window borderWidth).
	ogl ifNotNil:[ogl := ogl bufferRect: box].
	ogl ifNil:[ogl := OpenGL newIn: box].
	ogl ifNil:[^nil].
	phi ifNil: [phi := 0.0].
	(phi >= 359.0) ifTrue: [phi := 0.0]
	ifFalse: [phi := phi + 1.0].
	self glRenderOn: ogl.
	ogl swapBuffers.
! !

!MyOGLPanel0 methodsFor: 'accessing' stamp: 'daf 8/6/2007 20:05'!
phi
	"Answer the phi of the receiver"
	<bewareOf: #phiChanged>
	^self propertyValueAt: #phi! !

!MyOGLPanel0 methodsFor: 'accessing' stamp: 'daf 8/6/2007 20:05'!
phi: aValue
	"Modify the receiver's phi"
	^self propertyValueAt: #phi put: aValue with: #phiChanged! !

CPanel subclass: #COpenGLPanelCroquet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants'
	category: 'Tweak-OpenGL'!

!COpenGLPanelCroquet commentStamp: '<historical>' prior: 0!
Sample OpenGL rendering panel.

	CProjectMorph open: COpenGLPanel.!

COpenGLPanelCroquet defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="ogl" toSet="ogl:" changeEvent="oglChanged">ogl</field>
	<field toGet="oglCache" toSet="oglCache:" changeEvent="oglCacheChanged">oglCache</field>
	<field toGet="morphicCache" toSet="morphicCache:" changeEvent="morphicCacheChanged">morphicCache</field>
	<field toGet="projectMorph" toSet="projectMorph:" changeEvent="projectMorphChanged">projectMorph</field>
	<field virtual="true" serializable="false" toGet="fullScreen" toSet="fullScreen:">fullScreen</field>
	<field virtual="true" serializable="false" toGet="fullWindow" toSet="fullWindow:">fullWindow</field>
	<field virtual="true" serializable="false" toGet="useOpenGL" toSet="useOpenGL:">useOpenGL</field>
</fields>'!

!COpenGLPanelCroquet methodsFor: 'menu' stamp: 'sn 3/2/2013 12:26'!
addSubMenusTo: aMenu
	{
		{'File'. self fileMenu}.
		{'Extras'. self extrasMenu}.
	} do:[:spec|
		spec last ifNotNil:[
			aMenu add: spec first subMenu: spec last.
		].
	].! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
beginOverlay: ogl
	"Set up gl to provide overlay drawing - this is done in pixel coordinates"
	ogl glMatrixMode: GLProjection.
	ogl glPushMatrix.
	ogl glLoadIdentity.
	ogl glMatrixMode: GLModelview.
	ogl glPushMatrix.
	ogl glLoadIdentity.
	ogl glTranslated: -1 with: 1 with: 0.0.
	ogl glScaled: (2.0 / bounds width) with: (-2.0 / bounds height) with: 1.0.
	ogl glDisable: GLDepthTest.
	ogl glEnable: GLBlend.
	ogl glBlendFunc: GLOne  with: GLOneMinusSrcAlpha.! !

!COpenGLPanelCroquet methodsFor: 'initialize' stamp: 'sn 3/2/2013 12:26'!
destroy
	self stopRender.
	super destroy.! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
drawWorldOn: aCanvas
"This is the main world-drawing hook method (the top of the redraw loop). If errors occur during rendering, don't render again until the user proceeds from the debugger. Stop rendering entirely if the user abandons"

	[[
		self render.		
		"reinstall renderer once it completes successfully,
		either normally or after proceeding from a debugger"
		self resumeRender.
	] on: UnhandledError do: [:ex |
		"uninstall renderer if there was an error"
		self pauseRender.
		ex pass.
	]] ifCurtailed: [
		"kill the renderer and clean up OpenGL if the user terminated
		the renderer, presumably by abandoning a debugger"
		self stopRender.
	].
	^#()! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
endOverlay: ogl
	"Set up gl to provide overlay drawing - this is done in pixel coordinates"
	ogl glDisable: GLBlend.
	ogl glMatrixMode: GLModelview.
	ogl glPopMatrix.
	ogl glMatrixMode: GLProjection.
	ogl glPopMatrix.
	ogl glMatrixMode: GLModelview.
! !

!COpenGLPanelCroquet methodsFor: 'menu' stamp: 'sn 3/2/2013 12:26'!
extrasMenu
	| menu |
	menu := CMenu new.
	(menu add: 'Use OpenGL' target: self action: #toggleOpenGL)
		checked: useOpenGL;
		tag: #useOpenGL.
	(menu add:'Full Screen' target: self action: #toggleFullScreen)
		checked: fullScreen;
		tag: #fullScreen.
	(menu add:'Full Window' target: self action: #toggleFullWindow)
		checked: fullWindow;
		tag: #fullWindow.
	^menu! !

!COpenGLPanelCroquet methodsFor: 'menu' stamp: 'sn 3/2/2013 12:26'!
fileMenu
	| menu |
	menu := CMenu new.
	menu add: 'New...' subMenu: self newFileMenu.
	menu add: 'Open File...' target: self action: #openFile.
	menu add: 'Save File As...' target: self action: #saveFileAs.
	menu add: 'Show Progress' target: self action: #showProgress.
	menu addSeparator.
	menu add: 'Quit' target: self action: #quitApp.
	^menu! !

!COpenGLPanelCroquet methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:26'!
fullScreen
"True if squeak is occupying the entire screen, false if it is in an OS window"

	^ Tweak fullScreenMode! !

!COpenGLPanelCroquet methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:26'!
fullScreen: aBoolean
"Enable/disable full screen mode"

	Tweak fullScreenMode: aBoolean! !

!COpenGLPanelCroquet methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:26'!
fullWindow
"True if Tweak is using all the screen space available to squeak; false if it is in a Morphic window"

	^ projectMorph fullScreenMode! !

!COpenGLPanelCroquet methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:26'!
fullWindow: aBoolean
"Enable/disable tweak from using the entire squeak screen space"

	projectMorph fullScreenMode: aBoolean! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
glRenderCostume: aCostume on: ogl
	"Render a Tweak costume in OpenGL"
	| box formCache material |

	aCostume visible ifFalse:[^self].
	box := aCostume drawingBounds.
	box := box origin asIntegerPoint corner: box corner asIntegerPoint.
	formCache := aCostume localCache ifNil:[^nil]. "no cache, no render"
	"grab the texture cache"
	material := oglCache at: aCostume ifAbsent:[nil].
	"make sure it hasn't changed"
	(material == nil or:[material textureForm ~~ formCache form]) ifTrue:[
		material ifNotNil:[ogl deleteTexture: material texture tform].
		material := formCache material.
		material ifNotNil:[oglCache at: aCostume put: material].
	].

	material ifNil:[^nil]. "suppress render for this frame if no material"

	self
		glRenderOverlayMaterial: material
		atRectangle: box
		withTransform: aCostume transform
		on: ogl! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
glRenderOverlayMaterial: aMaterial atRectangle: aRectangle withTransform: aTransform on: ogl
"Render a 2d material on the screen"
	| tfm m44 tw th |

	"draw the costume"
	aMaterial enable: ogl.
	tfm := aTransform.
	ogl glPushMatrix.
	ogl glTranslatef: tfm offset x with: tfm offset y with: 0.0.
	tfm isPureTranslation ifFalse:[
		tfm := tfm asMatrixTransform2x3.
		m44 := Matrix4x4 new.
		m44 a11: tfm a11; a12: tfm a21; a21: tfm a12; a22: tfm a22.
		ogl glMultMatrixf: m44.
	].
	tw := aRectangle width asFloat / aMaterial textureForm width asFloat.
	th := aRectangle height asFloat / aMaterial textureForm height asFloat.
	ogl glBegin: GLQuads;
		glTexCoord2f: 0.0 with: th;
		glVertex2f: aRectangle left with: aRectangle bottom;

		glTexCoord2f: tw with: th;
		glVertex2f: aRectangle right with: aRectangle bottom;

		glTexCoord2f: tw with: 0.0;
		glVertex2f: aRectangle right with: aRectangle top;

		glTexCoord2f: 0.0 with: 0.0;
		glVertex2f: aRectangle left with: aRectangle top;

	glEnd.
	ogl glPopMatrix.
	aMaterial disable: ogl.
! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
glRenderOverlayOn: ogl
	"Display all overlapping players"
	| material viewPanelCostume cc |
	"viewPanelCostume is unused here but the idea is that if you have a separate view panel that should be traversed by the renderer you can identify it and it's going to be rendered by rendering all its elements instead of the entire view panel."
	viewPanelCostume := nil.
	oglCache ifNil:[oglCache := IdentityDictionary new].
	ogl glColor4f: 1.0 with: 1.0 with: 1.0 with: 1.0.
	self asPrimCostume do:[:aCostume|
		aCostume == viewPanelCostume ifTrue:[
			ogl glPushMatrix.
			ogl glTranslatef: aCostume left with: aCostume top with: 0.0.
			aCostume do:[:each| self glRenderCostume: each on: ogl].
			ogl glPopMatrix.
		] ifFalse:[self glRenderCostume: aCostume on: ogl].
	].
	"Also draw the hands if any of them are software rendering"
	Processor activeProject ifNotNilDo:[:proj|
		proj hands do:[:h|
			h needsSoftwareCursor
				ifTrue:[self glRenderCostume: h asPrimCostume on: ogl]]].
	"remove obsolete costumes from texture dictionary"
	oglCache keys "need a copy" do:[:aCostume|
		cc := aCostume container.
		(cc == self costume or:[cc == viewPanelCostume]) ifFalse:[
			"it got removed"
			aCostume localCache: nil.
			material := oglCache removeKey: aCostume.
			ogl deleteTexture: material texture sha.
		].
	].
! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
glRestoreMorph: aMorph on: ogl
"Draw aMorph, which should be on top of me, but OpenGL is hiding"

"adapted from updateCostume:, glRenderCostume:on:, and B3DHardwareEngine >> restoreMorphicForeground:above:"

	| box form material myBox |
	aMorph visible ifFalse: [^ self].
	
	myBox := projectMorph boundsInWorld.
	box := aMorph fullBoundsInWorld.
	material := morphicCache at: aMorph ifAbsent: [nil].
	form := material ifNotNil: [material textureForm].

	"figure out changes in size/depth"
	(form == nil 
		or: [form extent isPowerOfTwo not
			or: [form extent asLargerPowerOfTwo ~= box extent asLargerPowerOfTwo]]) ifTrue:[
		form := Form extent: box extent asLargerPowerOfTwo depth: 32.
	].

	form getCanvas translateBy: box origin negated during:[:canvas|
		canvas transformBy: aMorph transformFromWorld inverseTransformation
			clippingTo: myBox
			during: [:c| c fullDrawMorph: aMorph]].

	"make sure it hasn't changed"
	(material == nil or:[material textureForm ~~ form]) ifTrue:[
		material ifNotNil:[ogl deleteTexture: material texture tform].
		material := TMaterial new.
		material useForm: form mipmap: false  shrinkFit: true.
		material texture invalidate: form boundingBox.
		morphicCache at: aMorph put: material.
	].

	"fix up alpha and remember upload rectangle"
	form hasBeenModified ifTrue:[ | fixBlt |
		fixBlt := BitBlt toForm: material textureForm.
		fixBlt combinationRule: 40 "fixAlpha:with:".
		fixBlt halftoneForm: (Bitmap with: 16rFF000000).
		fixBlt copyBits.
		material texture invalidate: box.
	].

	self
		glRenderOverlayMaterial: material
		atRectangle: (box translateBy: myBox origin negated)
		withTransform: MatrixTransform2x3 identity
		on: ogl! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
glRestoreMorphicForegroundOn: ogl
"Draw all the morphs I'm hiding, but should be underneath"

	projectMorph ifNil: [^ self].
	(projectMorph send: #isMorph) ifFalse: [^ self].
	morphicCache ifNil:[morphicCache := IdentityDictionary new].
	(projectMorph morphsInFrontOverlapping: projectMorph boundsInWorld)
		reverseDo: [:aMorph | self glRestoreMorph: aMorph on: ogl].

	"remove obsolete morphs from texture dictionary"
	morphicCache keys "need a copy" do: [:aMorph |
		aMorph owner == World ifFalse:[ | material |
			"it got removed"
			material := morphicCache removeKey: aMorph.
			ogl deleteTexture: material texture tform.
		].
	].
! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
initializeOpenGlWithBounds: bnds
	ogl := OpenGL newIn: bnds.
	^ogl
! !

!COpenGLPanelCroquet methodsFor: 'menu' stamp: 'sn 3/2/2013 12:26'!
installMenu
	"Create and install the menu"
	self menu ifNotNil:[self menu destroy].
	self menu: CMenuBar new.
	self menu floating: false.
	self menu borderWidth: 1; borderStyle: #raised.
	self menu hResizing: #spaceFill.
	self addSubMenusTo: self menu.! !

!COpenGLPanelCroquet methodsFor: 'initialize' stamp: 'sn 3/2/2013 12:26'!
isSealedApplication
	"Answer whether we're currently running as a sealed application."
	^false! !

!COpenGLPanelCroquet methodsFor: 'layout' stamp: 'sn 3/2/2013 12:26'!
layoutEverything
	"Lay out all the parts in the current extent."
	| box |
	box := self bounds.
	self menu topLeft: box topLeft-1.
	self menu width: box width+2.
	self menu fullBounds.
! !

!COpenGLPanelCroquet methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:26'!
morphicCache
	"Answer the morphicCache of the receiver"
	<bewareOf: #morphicCacheChanged>
	^self propertyValueAt: #morphicCache! !

!COpenGLPanelCroquet methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:26'!
morphicCache: aValue
	"Modify the receiver's morphicCache"
	^self propertyValueAt: #morphicCache put: aValue with: #morphicCacheChanged! !

!COpenGLPanelCroquet methodsFor: 'menu' stamp: 'sn 3/2/2013 12:26'!
newFileMenu
	| menu |
	menu := CMenu new.
	menu add: 'Browser' target: StandardToolSet action: #openClassBrowser.
	menu add: 'Workspace' target: StandardToolSet action: #openWorkspace.
	menu add: 'Transcript' target: Transcript action: #open.
	menu add: 'TestRunner' target: TestRunner action: #open.
	menu addSeparator.
	menu add: 'File List' target: FileList action: #open.
	^menu! !

!COpenGLPanelCroquet methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:26'!
ogl
	"Answer the ogl of the receiver"
	<bewareOf: #oglChanged>
	^self propertyValueAt: #ogl! !

!COpenGLPanelCroquet methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:26'!
ogl: aValue
	"Modify the receiver's ogl"
	^self propertyValueAt: #ogl put: aValue with: #oglChanged! !

!COpenGLPanelCroquet methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:26'!
oglCache
	"Answer the oglCache of the receiver"
	<bewareOf: #oglCacheChanged>
	^self propertyValueAt: #oglCache! !

!COpenGLPanelCroquet methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:26'!
oglCache: aValue
	"Modify the receiver's oglCache"
	^self propertyValueAt: #oglCache put: aValue with: #oglCacheChanged! !

!COpenGLPanelCroquet methodsFor: 'initialize' stamp: 'sn 3/2/2013 12:26'!
onDisplayHookChanged
"Called when we toggle OpenGL"
	<on: displayHookChanged in: project>
	(self menu itemTagged: #useOpenGL) checked: useOpenGL! !

!COpenGLPanelCroquet methodsFor: 'layout' stamp: 'sn 3/2/2013 12:26'!
onExtentChanged
	"Window has been resized"
	<on: extentChanged>
	"We only need the last extentChanged message; 
	signal DropAllButLastEvent to get rid of any intermediates"
	DropAllButLastEvent signal.
	self layoutEverything.! !

!COpenGLPanelCroquet methodsFor: 'initialize' stamp: 'sn 3/2/2013 12:26'!
onSuspend
"Turn off the renderer during a minimize and other out of world states, then turn it back on when in world again"

	<on: suspend>
	ogl ifNil: [^ self].

	self stopRender.
	self waitUntil: #resume.
	self startRender.! !

!COpenGLPanelCroquet methodsFor: 'menu' stamp: 'sn 3/2/2013 12:26'!
openFile
	^CFileOpenDialog openImageFile! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
pauseRender
	Processor activeProject displayHook: nil! !

!COpenGLPanelCroquet methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:26'!
projectMorph
	"Answer the projectMorph of the receiver"
	<bewareOf: #projectMorphChanged>
	^self propertyValueAt: #projectMorph! !

!COpenGLPanelCroquet methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:26'!
projectMorph: aValue
	"Modify the receiver's projectMorph"
	^self propertyValueAt: #projectMorph put: aValue with: #projectMorphChanged! !

!COpenGLPanelCroquet methodsFor: 'menu' stamp: 'sn 3/2/2013 12:26'!
quitApp
	"Quit the app"
	self isSealedApplication ifTrue:[
		"This is the sealed application case."
		Smalltalk quitPrimitive.
	] ifFalse: [
		"Workaround until this can be fixed properly... File/exit from fullScreen
 		sometimes leaves a zombie UI appearance covering the Squeak desktop."
		window fullScreenMode ifTrue: [
			self toggleFullScreen.
		].
		"Attempting to close or delete the containing system window from 
	 	within this menu callback causes grief; the CProjectMorph 
	 	does not like to be dismantled from within itself."
		WorldState addDeferredUIMessage:(MessageSend
			receiver: self window window selector: #closeBoxHit).
		WorldState addDeferredUIMessage:(MessageSend
			receiver: World selector: #restoreMorphicDisplay).
	].
! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
render
	| globalBounds zeroBounds |
	globalBounds := self globalBounds translateBy: projectMorph boundsInWorld origin.
	ogl ifNil:[
		self initializeOpenGlWithBounds: globalBounds.
		ogl ifNil: [self error: 'Cannot initialize OpenGL.' ].
	] ifNotNil:[ 
		ogl := ogl bufferRect: globalBounds. 
	].
	zeroBounds := globalBounds translateBy: globalBounds origin negated.
	ogl makeCurrent.
	ogl camera: TCamera new.
	ogl camera bounds: zeroBounds.
	ogl camera initFrustum: ogl. "tweak is drawn in the wrong place without this"
	self updateTweak. "update tweak caches"
	ogl beginFrame.
	self renderScene: ogl. "render the 3d scene"
	self renderOverlay: ogl. "render the tweak overlay"
	ogl endFrame.
	ogl swapBuffers.
! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
renderOverlay: ogl
	"Set up gl to provide overlay drawing - this is done in pixel coordinates"
	ogl glDisable: GLLighting.
	self beginOverlay: ogl.
	self glRenderOverlayOn: ogl.
	self glRestoreMorphicForegroundOn: ogl.
	self endOverlay: ogl.
	ogl glEnable: GLLighting.
! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
renderScene: ogl
	"Render the 3d scene"
	ogl glClearColor: 1.0 with: 0.0 with: 0.0 with: 1.0.
	ogl glClear: (GLColorBufferBit bitOr: (GLDepthBufferBit bitOr: GLStencilBufferBit)).
! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
resumeRender
	Processor activeProject displayHook: self! !

!COpenGLPanelCroquet methodsFor: 'menu' stamp: 'sn 3/2/2013 12:26'!
saveFileAs
	^CFileSaveDialog openImageFile! !

!COpenGLPanelCroquet methodsFor: 'menu' stamp: 'sn 3/2/2013 12:26'!
saveProject
! !

!COpenGLPanelCroquet methodsFor: 'menu' stamp: 'sn 3/2/2013 12:26'!
saveProjectAs! !

!COpenGLPanelCroquet methodsFor: 'menu' stamp: 'sn 3/2/2013 12:26'!
setFullScreen: aBoolean
	fullScreen := aBoolean.
	(self menu itemTagged: #fullScreen) checked: fullScreen! !

!COpenGLPanelCroquet methodsFor: 'menu' stamp: 'sn 3/2/2013 12:26'!
setFullWindow: aBoolean
	fullWindow := aBoolean.
	(self menu itemTagged: #fullWindow) checked: fullWindow! !

!COpenGLPanelCroquet methodsFor: 'initialize' stamp: 'sn 3/2/2013 12:26'!
setupCostume
	super setupCostume.
	self installMenu.
	self extent: 600@400.
	self fillColor: (Color r: 0.917 g: 0.912 b: 0.908)..
	self add: self menu.
! !

!COpenGLPanelCroquet methodsFor: 'menu' stamp: 'sn 3/2/2013 12:26'!
showProgress
	UIManager default displayProgress: 'Displaying Progress' 
		at: hand position from: 1 to: 100 during:[:bar|
		1 to: 100 do:[:i|
			self wait: 0.1.
			bar value: i.
		].
	].! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
startRender
	"Start OpenGL rendering"
	Processor activeProject displayHook: self.
	self invalidate.
! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
stopRender
	"Stop OpenGL rendering"
	Processor activeProject displayHook: nil.
	ogl ifNotNil:[ogl destroy. ogl := nil].
	oglCache := nil.
	self invalidate.
! !

!COpenGLPanelCroquet methodsFor: 'menu' stamp: 'sn 3/2/2013 12:26'!
toggleFullScreen
	self setFullScreen: fullScreen not! !

!COpenGLPanelCroquet methodsFor: 'menu' stamp: 'sn 3/2/2013 12:26'!
toggleFullWindow
	self setFullWindow: fullWindow not! !

!COpenGLPanelCroquet methodsFor: 'menu' stamp: 'sn 3/2/2013 12:26'!
toggleOpenGL
	useOpenGL := useOpenGL not! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
updateCostume: aCostume
	"Update the damage rectangles for the given costume"
	| box formCache material rectList bb |
	aCostume visible ifFalse:[^self].
	box := aCostume drawingBounds.
	box := box origin asIntegerPoint corner: box corner asIntegerPoint.
	formCache := aCostume localCache.
	(formCache isKindOf: COpenGLFormCache) 
		ifFalse:[aCostume localCache: (formCache := COpenGLFormCache new)].

	"figure out changes in size/depth"
	(formCache form == nil 
		or:[formCache form extent isPowerOfTwo not
			or:[formCache form extent asLargerPowerOfTwo ~= box extent asLargerPowerOfTwo]]) ifTrue:[
		formCache form: (Form extent: box extent asLargerPowerOfTwo depth: 32).
	].
	"repair damage"
	rectList := formCache 
		repairDamage: aCostume drawingBounds 
		using:[:cc| aCostume localFullDrawOn: cc].

	"grab the texture cache"
	material := formCache material.
	"make sure it hasn't changed"
	(material == nil or:[material textureForm ~~ formCache form]) ifTrue:[
		material := TMaterial new.
		material useForm: formCache form mipmap: false  shrinkFit: true.
		material texture invalidate: formCache form boundingBox.
		formCache material: material.
	].

	"fix up alpha and remember upload rectangle"
	bb := BitBlt toForm: material textureForm.
	bb combinationRule: 40 "fixAlpha:with:".
	bb halftoneForm: (Bitmap with: 16rFF000000).
	rectList do:[:r|
		| aRect |
		aRect := r translateBy: box origin negated.
		bb destRect: aRect.
		bb copyBits.
		material texture invalidate: aRect.
	].! !

!COpenGLPanelCroquet methodsFor: 'render' stamp: 'sn 3/2/2013 12:26'!
updateTweak
	"Render (update) the tweak portion of the UI for OpenGL-based display."
	self asPrimCostume do:[:aCostume|
		self updateCostume: aCostume.
	].
	"Also update the hands if any of them are software rendering"
	Processor activeProject ifNotNilDo:[:proj|
		proj hands do:[:h|
			h needsSoftwareCursor
				ifTrue:[self updateCostume: h asPrimCostume]
				ifFalse:[h asPrimCostume localCache: nil]]].! !

!COpenGLPanelCroquet methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:26'!
useOpenGL
	^ project displayHook == self! !

!COpenGLPanelCroquet methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:26'!
useOpenGL: aBoolean
	useOpenGL = aBoolean ifTrue: [^ aBoolean].
	aBoolean ifTrue: [self startRender] ifFalse: [self stopRender].
	^ useOpenGL
! !

CFormCache subclass: #COpenGLFormCache
	instanceVariableNames: 'material'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-OpenGL'!

!COpenGLFormCache commentStamp: '<historical>' prior: 0!
A Tweak form cache which also holds onto the material for easier processing by the client.!

!COpenGLFormCache methodsFor: 'accessing' stamp: 'ar 2/16/2010 10:45'!
material
	"Answer the material associated with this cache"
	^material! !

!COpenGLFormCache methodsFor: 'accessing' stamp: 'ar 2/16/2010 10:45'!
material: aTMaterial
	"Set the material associated with this cache"
	material := aTMaterial! !

Object subclass: #NullTerminatedStringArray
	instanceVariableNames: 'pointers externalStrings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-OpenGL'!

!NullTerminatedStringArray commentStamp: 'jcg 3/30/2005 07:55' prior: 0!
NullTerminatedStringArray is used for passing data to FFI functions that require a null-terminated array of null-terminated strings. For example, this class is suitable for the 'char* argv[]' argument of the 'main()' function in C programs. Another example is the arguments passed to the Cg compiler in the context of an OpenGL/Cg application. The first example does not require a null-terminated array, because the number of strings is stored in the 'argc' argument. However, the second example requires both the strings and the array to be null-terminated. 'pointers' stores a null-terminated list of pointers to the null-terminated strings stored in 'externalStrings'.!

!NullTerminatedStringArray class methodsFor: 'instance creation' stamp: 'daf 8/10/2007 18:15'!
withStrings: stringCollection
	^ self new strings: stringCollection! !

!NullTerminatedStringArray methodsFor: 'initialization' stamp: 'daf 8/10/2007 18:16'!
free
	(pointers isNil and: [externalStrings isNil])
		ifTrue: [^ self "Nothing to free."].
	externalStrings do: [:string | string free].
	pointers := nil.
	externalStrings := nil.! !

!NullTerminatedStringArray methodsFor: 'accessing' stamp: 'daf 8/10/2007 18:16'!
pointers
	"Answer a null-terminated array of pointers (an ExternalData) to null-terminated strings."
	^ pointers! !

!NullTerminatedStringArray methodsFor: 'testing' stamp: 'daf 8/10/2007 18:17'!
strings
	"Get Smalltalk Strings from byte data."
	^ externalStrings collect: [:string | (ExternalData fromHandle: string type: ExternalType char asPointerType) fromCString]! !

!NullTerminatedStringArray methodsFor: 'testing' stamp: 'daf 8/10/2007 18:18'!
strings2
	"Get Smalltalk Strings from byte data. This way is longer, but makes sure that 'pointers' is also correct."
	^ (1 to: externalStrings size) collect:
		[:ind | (ExternalData fromHandle: (pointers getHandle pointerAt: (ind-1)*4+1) type: ExternalType char asPointerType) fromCString]! !

!NullTerminatedStringArray methodsFor: 'initialization' stamp: 'daf 8/10/2007 18:20'!
strings: stringCollection
	| extern pointerBytes |
	(pointers notNil or: [externalStrings notNil])
		ifTrue: [self error: 'Pointers have not been freed.'].
	"Allocate space for each string individually, and copy the bytes over."
	externalStrings := stringCollection collect:
		[:string | extern := ExternalAddress allocate: string size + 1. 1 to: string size do:
			[:ind | extern byteAt: ind put: (string byteAt: ind)]. extern byteAt: string size + 1 put: 0. extern].
	"Create null-terminated array of pointers to strings."
	pointerBytes := ByteArray new: 4*(stringCollection size + 1).
	pointers := ExternalData fromHandle: pointerBytes type: ExternalType void asPointerType.
	externalStrings withIndexDo: [:string :ind | pointerBytes pointerAt: (ind-1)*4 + 1 put: string]. ! !

CPlayer subclass: #COpenGLPlayer
	instanceVariableNames: 'opengl'
	classVariableNames: ''
	poolDictionaries: 'GLExtConstants OpenGLConstants'
	category: 'Tweak-OpenGL'!

!COpenGLPlayer commentStamp: 'daf 7/15/2007 08:24' prior: 0!
This is Bert Freudenberg's hack to make an OpenGL player in Tweak.  Modified slightly from his Croquet Jasmine original for Croquet Hedgehog.!

COpenGLPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true">opengl</field>
	<field toGet="phi" toSet="phi:" changeEvent="phiChanged">phi</field>
	<field toGet="offsetDisplay" toSet="offsetDisplay:" changeEvent="offsetDisplayChanged">offsetDisplay</field>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
</fields>'!

!COpenGLPlayer methodsFor: 'private' stamp: 'sn 3/2/2013 12:31'!
destroy
	self destroyGl.
	super destroy.! !

!COpenGLPlayer methodsFor: 'private' stamp: 'bf 4/7/2005 01:18'!
destroyGl
	opengl ifNotNil: [
		opengl destroy. 
		opengl := nil.
	]! !

!COpenGLPlayer methodsFor: 'drawing' stamp: 'sn 3/2/2013 12:29'!
drawOn: aCanvas in: drawingBounds

	| myRect |
	myRect := self globalBounds.
	Processor activeProcess hand: Processor activeProject primaryHand.
	offsetDisplay ifNil: [
		offsetDisplay := (Sensor cursorPoint - Processor activeProject primaryHand position). "** hack **"
	].


	"myRect := myRect translateBy: offsetDisplay."
	  myRect := myRect translateBy: (self target window boundsInWorld origin + self target window 
borderWidth).
	myRect := myRect intersect: (0@0 extent: DisplayScreen actualScreenSize).
	opengl ifNotNil:[
		opengl := opengl bufferRect: myRect.
	].
	opengl ifNil: [
		opengl := OpenGL newIn: myRect.
		(opengl isNil "or: [opengl isOpenGLRenderer not]" )
			ifTrue: [
				self destroyOgl.
				^super drawOn: aCanvas in: drawingBounds].
	] ifNotNil: [
		opengl cleanup.
	].
	self glRenderOn: opengl.
	Display addExtraRegion: myRect for: self.
! !

!COpenGLPlayer methodsFor: 'drawing' stamp: 'bf 4/7/2005 01:19'!
forceToScreen
	opengl ifNotNil:[
		opengl swapBuffers ifFalse:[
			"Something went wrong"
			self destroyGl]]! !

!COpenGLPlayer methodsFor: 'drawing' stamp: 'mtf 1/24/2011 14:43'!
glRenderOn: ogl

	| dx dy |
	bounds width > bounds height
		ifTrue:[dx := 1.0. dy := ((bounds height)/(bounds width) asFloat).]
		ifFalse:[dy := 1.0. dx := ((bounds width)/(bounds height) asFloat).].

	ogl
		glClearColor: color red with: color green with: color blue with: 0.0;
		glClear: GLColorBufferBit+GLDepthBufferBit;
		glViewport: 0 with: 0 with: bounds width with: bounds height;
		glFrustum: dx negated with: dx with: dy negated with: dy with: 0.5 with: 100;

		glLoadIdentity;
		glTranslatef: 0.0 with: 0.0 with: -1.2;

		glRotatef: phi with: 0.0 with: 0.0 with: 1.0;
		glBegin: GLTriangles;
			glColor3f: 1.0 with: 0.0 with: 0.0;
			glVertex3f:  1.0 with: -1.0 with: 0.0;
			glColor3f: 0.0 with: 1.0 with: 0.0;
			glVertex3f:  0.0 with: 1.0 with: 0.0;
			glColor3f: 0.0 with: 0.0 with: 1.0;
			glVertex3f:  -1.0 with: -1.0 with: 0.0;
		glEnd! !

!COpenGLPlayer methodsFor: 'initialize' stamp: 'daf 3/31/2007 12:19'!
initialize
	super initialize.

	extent := 300@200.
	color := Color black.
	self userDraw: true.
	offsetDisplay := nil.! !

!COpenGLPlayer methodsFor: 'accessing' stamp: 'daf 3/31/2007 12:19'!
offsetDisplay
	"Answer the offsetDisplay of the receiver"
	<bewareOf: #offsetDisplayChanged>
	^self propertyValueAt: #offsetDisplay! !

!COpenGLPlayer methodsFor: 'accessing' stamp: 'daf 3/31/2007 12:19'!
offsetDisplay: aValue
	"Modify the receiver's offsetDisplay"
	^self propertyValueAt: #offsetDisplay put: aValue with: #offsetDisplayChanged! !

!COpenGLPlayer methodsFor: 'events' stamp: 'bf 4/7/2005 01:19'!
onClosed
	<on: closed>
	self destroyGl.
! !

!COpenGLPlayer methodsFor: 'events' stamp: 'daf 3/31/2007 12:28'!
onTick
	<ticking: 100>
	(phi >= 359.0) ifTrue: [phi := 0.0]
	ifFalse: [phi := phi + 1.0].
	self invalidate! !

!COpenGLPlayer methodsFor: 'accessing' stamp: 'bf 4/7/2005 01:53'!
phi
	"Answer the phi of the receiver"
	<bewareOf: #phiChanged>
	^self propertyValueAt: #phi ifAbsent: [0.0]! !

!COpenGLPlayer methodsFor: 'accessing' stamp: 'bf 4/7/2005 01:52'!
phi: aValue
	"Modify the receiver's phi"
	^self propertyValueAt: #phi put: aValue with: #phiChanged! !

!COpenGLPlayer methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:27'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!COpenGLPlayer methodsFor: 'accessing' stamp: 'sn 3/2/2013 12:27'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

COpenGLPlayer subclass: #MyOGLPlayer0
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-OpenGL'!

!MyOGLPlayer0 commentStamp: 'daf 7/15/2007 08:27' prior: 0!
A translation of the OpenGL NeHe tutorial 5 for Tweak!

MyOGLPlayer0 defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!MyOGLPlayer0 methodsFor: 'drawing' stamp: 'mtf 1/24/2011 14:15'!
glRenderOn: ogl

	| dx dy |
		dx := bounds width asFloat.
		dy := bounds height asFloat.

	ogl
		glClearColor: color red with:  color green with:  color blue with:  0.0;
		glClear: GLColorBufferBit+GLDepthBufferBit;
		initFrustum: 45.0 bounds: (0@0 extent: dx@dy) zNear: 0.1 zFar: 100.0;

	"This is translated from the NeHe Tutorials Lesson 5"
		glShadeModel: GLSmooth;		"Enables Smooth Shading"
		glClearDepth: 1.0;				"Depth Buffer Setup"
		glEnable: GLDepthTest;			"Enables Depth Testing"
		glDepthFunc: GLLequal;			"The Type Of Depth Test To Do"
		glHint: GLPerspectiveCorrectionHint with:  GLNicest;	"Really Nice Perspective Calculations"

		glLoadIdentity;					"Reset The View"
		glTranslatef: -1.5 with: 0.0 with: -6.0;		"Move Left And Into The Screen"
		glRotatef: phi with: 0.0 with: 1.0 with: 0.0;		"Rotate The Pyramid On It's Y Axis"
		glBegin: GLTriangles;			"Start Drawing The Pyramid"

		glColor3f: 1.0 with: 0.0 with: 0.0;			"Red"
		glVertex3f:  0.0 with:  1.0 with:  0.0;		"Top Of Triangle (Front)"
		glColor3f: 0.0 with: 1.0 with: 0.0;			"Green"
		glVertex3f: -1.0 with: -1.0 with:  1.0;		"Left Of Triangle (Front)"
		glColor3f: 0.0 with: 0.0 with: 1.0;			"Blue"
		glVertex3f:  1.0 with: -1.0 with:  1.0;		"Right Of Triangle (Front)"

		glColor3f: 1.0 with: 0.0 with: 0.0;			"Red"
		glVertex3f:  0.0 with:  1.0 with:  0.0;		"Top Of Triangle (Right)"
		glColor3f: 0.0 with: 0.0 with: 1.0;			"Blue"
		glVertex3f:  1.0 with: -1.0 with:  1.0;		"Left Of Triangle (Right)"
		glColor3f: 0.0 with: 1.0 with: 0.0;			"Green"
		glVertex3f:  1.0 with: -1.0 with:  -1.0;		"Right Of Triangle (Right)"

		glColor3f: 1.0 with: 0.0 with: 0.0;			"Red"
		glVertex3f:  0.0 with:  1.0 with:  0.0;		"Top Of Triangle (Back)"
		glColor3f: 0.0 with: 1.0 with: 0.0;			"Green"
		glVertex3f:  1.0 with: -1.0 with:  -1.0;		"Left Of Triangle (Back)"
		glColor3f: 0.0 with: 0.0 with: 1.0;			"Blue"
		glVertex3f: -1.0 with: -1.0 with:  -1.0;		"Right Of Triangle (Back)"

		glColor3f: 1.0 with: 0.0 with: 0.0;			"Red"
		glVertex3f:  0.0 with:  1.0 with:  0.0;		"Top Of Triangle (Left)"
		glColor3f: 0.0 with: 0.0 with: 1.0;			"Blue"
		glVertex3f: -1.0 with: -1.0 with: -1.0;		"Left Of Triangle (Left)"
		glColor3f: 0.0 with: 1.0 with: 0.0;			"Green"
		glVertex3f: -1.0 with: -1.0 with:  1.0;		"Right Of Triangle (Left)"
		glEnd;							"Done Drawing The Pyramid"

		glLoadIdentity;
		glTranslatef: 1.5 with: 0.0 with: -7.0;		"Move Right And Into The Screen"
		glRotatef: phi with: 1.0 with: 1.0 with: 1.0;		"Rotate The Cube On X with:  Y & Z"
		glBegin: GLQuads;				"Start Drawing The Cube"

		glColor3f: 0.0 with: 1.0 with: 0.0;			"Set The Color To Green"
		glVertex3f:  1.0 with:  1.0 with: -1.0;		"Top Right Of The Quad (Top)"
		glVertex3f: -1.0 with:  1.0 with: -1.0;		"Top Left Of The Quad (Top)"
		glVertex3f: -1.0 with:  1.0 with:  1.0;		"Bottom Left Of The Quad (Top)"
		glVertex3f:  1.0 with:  1.0 with:  1.0;		"Bottom Right Of The Quad (Top)"

		glColor3f: 1.0 with: 0.5 with: 0.0;			"Set The Color To Orange"
		glVertex3f:  1.0 with: -1.0 with:  1.0;		"Top Right Of The Quad (Bottom)"
		glVertex3f: -1.0 with: -1.0 with:  1.0;		"Top Left Of The Quad (Bottom)"
		glVertex3f: -1.0 with: -1.0 with: -1.0;		"Bottom Left Of The Quad (Bottom)"
		glVertex3f:  1.0 with: -1.0 with: -1.0;		"Bottom Right Of The Quad (Bottom)"

		glColor3f: 1.0 with: 0.0 with: 0.0;			"Set The Color To Red"
		glVertex3f:  1.0 with:  1.0 with:  1.0;		"Top Right Of The Quad (Front)"
		glVertex3f: -1.0 with:  1.0 with:  1.0;		"Top Left Of The Quad (Front)"
		glVertex3f: -1.0 with: -1.0 with:  1.0;		"Bottom Left Of The Quad (Front)"
		glVertex3f:  1.0 with: -1.0 with:  1.0;		"Bottom Right Of The Quad (Front)"

		glColor3f: 1.0 with: 1.0 with: 0.0;			"Set The Color To Yellow"
		glVertex3f:  1.0 with: -1.0 with: -1.0;		"Bottom Left Of The Quad (Back)"
		glVertex3f: -1.0 with: -1.0 with: -1.0;		"Bottom Right Of The Quad (Back)"
		glVertex3f: -1.0 with:  1.0 with: -1.0;		"Top Right Of The Quad (Back)"
		glVertex3f:  1.0 with:  1.0 with: -1.0;		"Top Left Of The Quad (Back)"

		glColor3f: 0.0 with: 0.0 with: 1.0;			"Set The Color To Blue"
		glVertex3f: -1.0 with:  1.0 with:  1.0;		"Top Right Of The Quad (Left)"
		glVertex3f: -1.0 with:  1.0 with: -1.0;		"Top Left Of The Quad (Left)"
		glVertex3f: -1.0 with: -1.0 with: -1.0;		"Bottom Left Of The Quad (Left)"
		glVertex3f: -1.0 with: -1.0 with:  1.0;		"Bottom Right Of The Quad (Left)"

		glColor3f: 1.0 with: 0.0 with: 1.0;			"Set The Color To Violet"
		glVertex3f:  1.0 with:  1.0 with: -1.0;		"Top Right Of The Quad (Right)"
		glVertex3f:  1.0 with:  1.0 with:  1.0;		"Top Left Of The Quad (Right)"
		glVertex3f:  1.0 with: -1.0 with:  1.0;		"Bottom Left Of The Quad (Right)"
		glVertex3f:  1.0 with: -1.0 with: -1.0;		"Bottom Right Of The Quad (Right)"
		glEnd							"Done Drawing The Quad"
! !

COpenGLPlayer subclass: #MyOGLPlayer1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-OpenGL'!

!MyOGLPlayer1 commentStamp: 'daf 7/15/2007 08:33' prior: 0!
A trivial GLSL shader example!

MyOGLPlayer1 defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="prog" toSet="prog:" changeEvent="progChanged">prog</field>
</fields>'!

!MyOGLPlayer1 methodsFor: 'drawing' stamp: 'mtf 1/24/2011 14:17'!
glRenderOn: ogl

	| dx dy |
		dx := bounds width asFloat.
		dy := bounds height asFloat.

	ogl
		glClearColor: color red with: color green with: color blue with: 0.0;
		glClear: GLColorBufferBit+GLDepthBufferBit;
		initFrustum: 45.0 bounds: (0@0 extent: dx@dy) zNear: 0.1 zFar: 100.0;

	"This is translated from the NeHe Tutorials Lesson 5"
		glShadeModel: GLSmooth;		"Enables Smooth Shading"
		glClearDepth: 1.0;				"Depth Buffer Setup"
		glEnable: GLDepthTest;			"Enables Depth Testing"
		glDepthFunc: GLLequal;			"The Type Of Depth Test To Do"
		glHint: GLPerspectiveCorrectionHint with: GLNicest;	"Really Nice Perspective Calculations"

		glLoadIdentity;					"Reset The View"
		glTranslatef: -1.5 with:0.0 with:-6.0;		"Move Left And Into The Screen"
		glRotatef: phi with:0.0 with:1.0 with:0.0;		"Rotate The Pyramid On It's Y Axis"
		glBegin: GLTriangles;			"Start Drawing The Pyramid"

		glColor3f: 1.0 with:0.0 with:0.0;			"Red"
		glVertex3f:  0.0 with: 1.0 with: 0.0;		"Top Of Triangle (Front)"
		glColor3f: 0.0 with:1.0 with:0.0;			"Green"
		glVertex3f: -1.0 with:-1.0 with: 1.0;		"Left Of Triangle (Front)"
		glColor3f: 0.0 with:0.0 with:1.0;			"Blue"
		glVertex3f:  1.0 with:-1.0 with: 1.0;		"Right Of Triangle (Front)"

		glColor3f: 1.0 with:0.0 with:0.0;			"Red"
		glVertex3f:  0.0 with: 1.0 with: 0.0;		"Top Of Triangle (Right)"
		glColor3f: 0.0 with:0.0 with:1.0;			"Blue"
		glVertex3f:  1.0 with:-1.0 with: 1.0;		"Left Of Triangle (Right)"
		glColor3f: 0.0 with:1.0 with:0.0;			"Green"
		glVertex3f:  1.0 with:-1.0 with: -1.0;		"Right Of Triangle (Right)"

		glColor3f: 1.0 with:0.0 with:0.0;			"Red"
		glVertex3f:  0.0 with: 1.0 with: 0.0;		"Top Of Triangle (Back)"
		glColor3f: 0.0 with:1.0 with:0.0;			"Green"
		glVertex3f:  1.0 with:-1.0 with: -1.0;		"Left Of Triangle (Back)"
		glColor3f: 0.0 with:0.0 with:1.0;			"Blue"
		glVertex3f: -1.0 with:-1.0 with: -1.0;		"Right Of Triangle (Back)"

		glColor3f: 1.0 with:0.0 with:0.0;			"Red"
		glVertex3f:  0.0 with: 1.0 with: 0.0;		"Top Of Triangle (Left)"
		glColor3f: 0.0 with:0.0 with:1.0;			"Blue"
		glVertex3f: -1.0 with:-1.0 with:-1.0;		"Left Of Triangle (Left)"
		glColor3f: 0.0 with:1.0 with:0.0;			"Green"
		glVertex3f: -1.0 with:-1.0 with: 1.0;		"Right Of Triangle (Left)"
		glEnd.							"Done Drawing The Pyramid"

	self loadShader: ogl.
	ogl
		glLoadIdentity;
		glTranslatef: 1.5 with:0.0 with:-7.0;		"Move Right And Into The Screen"
		glRotatef: phi with:1.0 with:1.0 with:1.0;		"Rotate The Cube On X with: Y & Z"
		glBegin: GLQuads;				"Start Drawing The Cube"

		glColor3f: 0.0 with:1.0 with:0.0;			"Set The Color To Green"
		glVertex3f:  1.0 with: 1.0 with:-1.0;		"Top Right Of The Quad (Top)"
		glVertex3f: -1.0 with: 1.0 with:-1.0;		"Top Left Of The Quad (Top)"
		glVertex3f: -1.0 with: 1.0 with: 1.0;		"Bottom Left Of The Quad (Top)"
		glVertex3f:  1.0 with: 1.0 with: 1.0;		"Bottom Right Of The Quad (Top)"

		glColor3f: 1.0 with:0.5 with:0.0;			"Set The Color To Orange"
		glVertex3f:  1.0 with:-1.0 with: 1.0;		"Top Right Of The Quad (Bottom)"
		glVertex3f: -1.0 with:-1.0 with: 1.0;		"Top Left Of The Quad (Bottom)"
		glVertex3f: -1.0 with:-1.0 with:-1.0;		"Bottom Left Of The Quad (Bottom)"
		glVertex3f:  1.0 with:-1.0 with:-1.0;		"Bottom Right Of The Quad (Bottom)"

		glColor3f: 1.0 with:0.0 with:0.0;			"Set The Color To Red"
		glVertex3f:  1.0 with: 1.0 with: 1.0;		"Top Right Of The Quad (Front)"
		glVertex3f: -1.0 with: 1.0 with: 1.0;		"Top Left Of The Quad (Front)"
		glVertex3f: -1.0 with:-1.0 with: 1.0;		"Bottom Left Of The Quad (Front)"
		glVertex3f:  1.0 with:-1.0 with: 1.0;		"Bottom Right Of The Quad (Front)"

		glColor3f: 1.0 with:1.0 with:0.0;			"Set The Color To Yellow"
		glVertex3f:  1.0 with:-1.0 with:-1.0;		"Bottom Left Of The Quad (Back)"
		glVertex3f: -1.0 with:-1.0 with:-1.0;		"Bottom Right Of The Quad (Back)"
		glVertex3f: -1.0 with: 1.0 with:-1.0;		"Top Right Of The Quad (Back)"
		glVertex3f:  1.0 with: 1.0 with:-1.0;		"Top Left Of The Quad (Back)"

		glColor3f: 0.0 with:0.0 with:1.0;			"Set The Color To Blue"
		glVertex3f: -1.0 with: 1.0 with: 1.0;		"Top Right Of The Quad (Left)"
		glVertex3f: -1.0 with: 1.0 with:-1.0;		"Top Left Of The Quad (Left)"
		glVertex3f: -1.0 with:-1.0 with:-1.0;		"Bottom Left Of The Quad (Left)"
		glVertex3f: -1.0 with:-1.0 with: 1.0;		"Bottom Right Of The Quad (Left)"

		glColor3f: 1.0 with:0.0 with:1.0;			"Set The Color To Violet"
		glVertex3f:  1.0 with: 1.0 with:-1.0;		"Top Right Of The Quad (Right)"
		glVertex3f:  1.0 with: 1.0 with: 1.0;		"Top Left Of The Quad (Right)"
		glVertex3f:  1.0 with:-1.0 with: 1.0;		"Bottom Left Of The Quad (Right)"
		glVertex3f:  1.0 with:-1.0 with:-1.0;		"Bottom Right Of The Quad (Right)"
		glEnd.							"Done Drawing The Quad"

	ogl glUseProgramObjectARB: 0.
! !

!MyOGLPlayer1 methodsFor: 'initialize' stamp: 'daf 6/11/2007 20:06'!
initialize
	super initialize.

	prog := nil.
! !

!MyOGLPlayer1 methodsFor: 'drawing' stamp: 'daf 6/11/2007 20:05'!
loadShader: ogl
	"Oh - and here is some test code I use (in conjunction with Joshuas 
	NullTerminatedStringArray ) to load some simple GLSL-shaders"

	| vertSource vertShader str arr fragShader fragSource |

	prog ifNil: [
		vertShader := ogl glCreateShaderObjectARB: GLVertexShaderARB.
		fragShader := ogl glCreateShaderObjectARB: GLFragmentShaderARB.
	
		vertSource := '
			void main() {
				gl_Position = ftransform();
			}
		'.

		fragSource := '
			void main() {
				gl_FragColor = vec4(0.8,0.4,0.2,1.0);
			}
		'.

		arr := Array new: 1.
		arr at: 1 put: vertSource.
		str := NullTerminatedStringArray withStrings: arr.
		ogl glShaderSourceARB: vertShader with: 1 with: str pointers getHandle with: nil.
		str free.

		arr at: 1 put: fragSource.
		str := NullTerminatedStringArray withStrings: arr.
		ogl glShaderSourceARB: fragShader with: 1 with: str pointers getHandle with: nil.
		str free.

		ogl glCompileShaderARB: vertShader.
		ogl glCompileShaderARB: fragShader.

		prog := ogl glCreateProgramObjectARB.
		ogl glAttachObjectARB: prog with: vertShader.
		ogl glAttachObjectARB: prog with: fragShader.

		ogl glLinkProgramARB: prog.
	].

	ogl glUseProgramObjectARB: prog.
! !

!MyOGLPlayer1 methodsFor: 'accessing' stamp: 'daf 6/11/2007 20:06'!
prog
	"Answer the prog of the receiver"
	<bewareOf: #progChanged>
	^self propertyValueAt: #prog! !

!MyOGLPlayer1 methodsFor: 'accessing' stamp: 'daf 6/11/2007 20:06'!
prog: aValue
	"Modify the receiver's prog"
	^self propertyValueAt: #prog put: aValue with: #progChanged! !

COpenGLPlayer subclass: #MyOGLPlayer5
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-OpenGL'!

!MyOGLPlayer5 commentStamp: 'daf 7/15/2007 08:29' prior: 0!
Tweak player for OpenGL with GLSL for Wrinkle!

MyOGLPlayer5 defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="prog" toSet="prog:" changeEvent="progChanged">prog</field>
	<field toGet="scaleFactor" toSet="scaleFactor:" changeEvent="scaleFactorChanged">scaleFactor</field>
	<field toGet="rotFactor" toSet="rotFactor:" changeEvent="rotFactorChanged">rotFactor</field>
	<field toGet="col1Factor" toSet="col1Factor:" changeEvent="col1FactorChanged">col1Factor</field>
	<field toGet="col2Factor" toSet="col2Factor:" changeEvent="col2FactorChanged">col2Factor</field>
	<field toGet="pickedColor1" toSet="pickedColor1:" changeEvent="pickedColor1Changed">pickedColor1</field>
	<field toGet="pickedColor2" toSet="pickedColor2:" changeEvent="pickedColor2Changed">pickedColor2</field>
	<field toGet="currFrag" toSet="currFrag:" changeEvent="currFragChanged">currFrag</field>
	<field toGet="selectFrag" toSet="selectFrag:" changeEvent="selectFragChanged">selectFrag</field>
	<field toGet="reloadFlag" toSet="reloadFlag:" changeEvent="reloadFlagChanged">reloadFlag</field>
</fields>'!

!MyOGLPlayer5 methodsFor: 'error handling' stamp: 'mtf 1/24/2011 14:18'!
checkCompileForError: anObj in: ogl
	"Check for any GLSL compile errors"
	| status |

	status := IntegerArray new: 1.
	ogl glGetObjectParameterivARB: anObj with: GLObjectCompileStatusARB with: status.
	((status first) = GLTrue) ifFalse: [self showlog: anObj in: ogl]
! !

!MyOGLPlayer5 methodsFor: 'error handling' stamp: 'daf 7/14/2007 08:23'!
checkForError: ogl
	"Check for any OpenGL errors"
	| status |

	status := ogl glGetError.
	(status = GLNoError) ifFalse: [self handleError: status printString]
! !

!MyOGLPlayer5 methodsFor: 'error handling' stamp: 'daf 7/14/2007 09:34'!
checkForGLSL: ogl
	"Check for GLSL support"
	"this is a pretty minimal check"
	| status |

	status := ogl extensions includes: #'GL_ARB_shading_language_100'.
	status ifFalse:  [ self handleError: 'GLSL is not supported\Try running:\GPUInfo new chkGLSLSupport' withCRs. ]
! !

!MyOGLPlayer5 methodsFor: 'error handling' stamp: 'mtf 1/24/2011 14:19'!
checkLinkForError: anObj in: ogl
	"Check for any GLSL link errors"
	| status |

	status := IntegerArray new: 1.
	ogl glGetObjectParameterivARB: anObj with: GLObjectLinkStatusARB with: status.
	((status first) = GLTrue) ifFalse: [self showlog: anObj in: ogl]
! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:24'!
col1Factor
	"Answer the col1Factor of the receiver"
	<bewareOf: #col1FactorChanged>
	^self propertyValueAt: #col1Factor! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:24'!
col1Factor: aValue
	"Modify the receiver's col1Factor"
	^self propertyValueAt: #col1Factor put: aValue with: #col1FactorChanged! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:24'!
col2Factor
	"Answer the col2Factor of the receiver"
	<bewareOf: #col2FactorChanged>
	^self propertyValueAt: #col2Factor! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:24'!
col2Factor: aValue
	"Modify the receiver's col2Factor"
	^self propertyValueAt: #col2Factor put: aValue with: #col2FactorChanged! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/28/2007 09:39'!
currFrag
	"Answer the currFrag of the receiver"
	<bewareOf: #currFragChanged>
	^self propertyValueAt: #currFrag! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/28/2007 09:39'!
currFrag: aValue
	"Modify the receiver's currFrag"
	^self propertyValueAt: #currFrag put: aValue with: #currFragChanged! !

!MyOGLPlayer5 methodsFor: 'drawing' stamp: 'mtf 1/24/2011 14:19'!
destroyGl
	opengl ifNotNil: [
		prog ifNotNil: [
			opengl glDeleteObjectARB: prog.
			prog := nil.
		].
		opengl destroy. 
		opengl := nil.
	]! !

!MyOGLPlayer5 methodsFor: 'pixel shader' stamp: 'daf 7/4/2007 11:03'!
fragChecker
^'	uniform float inScale;
	uniform float inRotate;
	uniform vec4 inColor1;
	uniform vec4 inColor2;
	void main() {
		float scaled = inScale/100.0;
		float myX = ((gl_TexCoord[0].s * 2.0) - 1.0) / scaled;
		float myY = ((gl_TexCoord[0].t * 2.0) - 1.0) / scaled;
		float rotX = cos(inRotate)*myX - sin(inRotate)*myY;
		float rotY = sin(inRotate)*myX + cos(inRotate)*myY;
		float myZ = step(0.0, sin(rotX) * cos(rotY));
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = myColor;
	}'
! !

!MyOGLPlayer5 methodsFor: 'pixel shader' stamp: 'daf 7/14/2007 09:46'!
fragError
^'	void main() {
		There must be a compile error in here somewhere;
	}'
! !

!MyOGLPlayer5 methodsFor: 'pixel shader' stamp: 'daf 7/4/2007 11:01'!
fragExample0
^'	uniform float inScale;
	uniform float inRotate;
	uniform vec4 inColor1;
	uniform vec4 inColor2;
	void main() {
		float scaled = inScale/100.0;
		float myX = ((gl_TexCoord[0].s * 2.0) - 1.0) / scaled;
		float myY = ((gl_TexCoord[0].t * 2.0) - 1.0) / scaled;
		float rotX = cos(inRotate)*myX - sin(inRotate)*myY;
		float rotY = sin(inRotate)*myX + cos(inRotate)*myY;
		float myZ = sin(rotX+sin(rotY+sin(rotX))) - sin(rotY+sin(rotX+sin(rotY)));
		myZ = (fract(myZ) + 1.0) / 2.0;
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = myColor;
	}'
! !

!MyOGLPlayer5 methodsFor: 'pixel shader' stamp: 'daf 7/4/2007 11:02'!
fragFuzzyChecker
^'	uniform float inScale;
	uniform float inRotate;
	uniform vec4 inColor1;
	uniform vec4 inColor2;
	void main() {
		float scaled = inScale/100.0;
		float myX = ((gl_TexCoord[0].s * 2.0) - 1.0) / scaled;
		float myY = ((gl_TexCoord[0].t * 2.0) - 1.0) / scaled;
		float rotX = cos(inRotate)*myX - sin(inRotate)*myY;
		float rotY = sin(inRotate)*myX + cos(inRotate)*myY;
		float myZ = smoothstep(-0.5, 0.5, sin(rotX) * cos(rotY));
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = myColor;
	}'
! !

!MyOGLPlayer5 methodsFor: 'pixel shader' stamp: 'daf 7/4/2007 11:02'!
fragHexagon
^'	uniform float inScale;
	uniform float inRotate;
	uniform vec4 inColor1;
	uniform vec4 inColor2;

	float symteeth(float a) {
		float result = abs(2.0*fract(a+0.5)-1.0);
		return result;
	}

	void main() {
		float scaled = inScale/100.0;
		float myX = ((gl_TexCoord[0].s * 2.0) - 1.0) / scaled;
		float myY = ((gl_TexCoord[0].t * 2.0) - 1.0) / scaled;
		float rotX = cos(inRotate)*myX - sin(inRotate)*myY;
		float rotY = sin(inRotate)*myX + cos(inRotate)*myY;
		float myZ = symteeth(2.0*rotX) +
					symteeth(rotX+sqrt(3.0)*rotY) +
					symteeth(rotX-sqrt(3.0)*rotY) - 1.5;
		myZ = step(0.0,myZ);
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = myColor;
	}'
! !

!MyOGLPlayer5 methodsFor: 'pixel shader' stamp: 'daf 8/1/2007 22:33'!
fragNoise1
^'	uniform float inScale;
	uniform float inRotate;
	uniform vec4 inColor1;
	uniform vec4 inColor2;

	float ergodicxy (float ix, float iy) {
		float n = 497.0 + (79.0*ix) + (37.0*iy);
		float ret = float(mod((n*(n*n*15731.0+789221.0)+1376312589.0),2147483647.0)) / 2147483648.0;
		return ret;
	}

	void main() {
		float scaled = inScale/1000.0;
		float myX = ((gl_TexCoord[0].s * 2.0) - 1.0) / scaled;
		float myY = ((gl_TexCoord[0].t * 2.0) - 1.0) / scaled;
		float rotX = cos(inRotate)*myX - sin(inRotate)*myY;
		float rotY = sin(inRotate)*myX + cos(inRotate)*myY;
		float myZ = ergodicxy(floor(rotX),floor(rotY));
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = myColor;
	}'
! !

!MyOGLPlayer5 methodsFor: 'pixel shader' stamp: 'daf 8/1/2007 22:32'!
fragNoise2
^'	uniform float inScale;
	uniform float inRotate;
	uniform vec4 inColor1;
	uniform vec4 inColor2;

	float ergvecxy (float fx, float fy, float a, float b) {
		float ix = floor(fx);
		float iy = floor(fy);
		float n = 497.0 + (79.0*ix+12.0) + (37.0*iy-31.0);
		float n2=n*n;
		float ret = (a * float(mod(n*(n2*599479.0+649657.0)+312587137.0,2147483647.0)) +
			b * float(mod(n*(n2*157031.0+789221.0)+1376312589.0,2147483647.0))) / 2147483648.0;
		return ret;
	}

	vec2 herm (float a) {
		float n = a*a*(3.0-2.0*a);
		vec2 ret = vec2(n, 1.0-n);
		return ret;
	}

	vec4 entfr (float a) {
		float n = floor(a);
		float r = a-n;
		vec4 ret = vec4(n,n+1.0,r,r-1.0);
		return ret;
	}

	float grnoise2 (vec2 a) {
		/* (nx,nx1,rx,mx) = entfr x */
		vec4 vx4 = entfr(a.x);
		/* (ny,ny1,ry,my) = entfr y */
		vec4 vy4 = entfr(a.y);
		/* (nrx,nmx) = herm rx */
		vec2 vx2 = herm(vx4.z);
		/* (nry,nmy) = herm ry */
		vec2 vy2 = herm(vy4.z);
		/* = nmx*(nmy*ergvecxy nx ny rx ry + nry*ergvecxy nx ny1 rx my) + 
			nrx*(nmy*ergvecxy nx1 ny mx ry+ nry*ergvecxy nx1 ny1 mx my) */
		float ret = vx2.y*(vy2.y*ergvecxy(vx4.x,vy4.x,vx4.z,vy4.z) + vy2.x*ergvecxy(vx4.x,vy4.y,vx4.z,vy4.w)) + 
			vx2.x*(vy2.y*ergvecxy(vx4.y,vy4.x,vx4.w,vy4.z)+ vy2.x*ergvecxy(vx4.y,vy4.y,vx4.w,vy4.w));
		return ret;
	}

	void main() {
		float scaled = inScale/100.0;
		float myX = ((gl_TexCoord[0].s * 2.0) - 1.0) / scaled;
		float myY = ((gl_TexCoord[0].t * 2.0) - 1.0) / scaled;
		float rotX = cos(inRotate)*myX - sin(inRotate)*myY;
		float rotY = sin(inRotate)*myX + cos(inRotate)*myY;
		float myZ = (grnoise2(vec2(rotX,rotY)) +1.0) / 2.0;
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = myColor;
	}'
! !

!MyOGLPlayer5 methodsFor: 'pixel shader' stamp: 'daf 8/1/2007 22:30'!
fragNoise3
^'	uniform float inScale;
	uniform float inRotate;
	uniform vec4 inColor1;
	uniform vec4 inColor2;

	float ergvecxy (float fx, float fy, float a, float b) {
		float ix = floor(fx);
		float iy = floor(fy);
		float n = 497.0 + (79.0*ix+12.0) + (37.0*iy-31.0);
		float n2=n*n;
		float ret = (a * float(mod(n*(n2*599479.0+649657.0)+312587137.0,2147483647.0)) +
			b * float(mod(n*(n2*157031.0+789221.0)+1376312589.0,2147483647.0))) / 2147483648.0;
		return ret;
	}

	vec2 herm (float a) {
		float n = a*a*(3.0-2.0*a);
		vec2 ret = vec2(n, 1.0-n);
		return ret;
	}

	vec4 entfr (float a) {
		float n = floor(a);
		float r = a-n;
		vec4 ret = vec4(n,n+1.0,r,r-1.0);
		return ret;
	}

	float grnoise2 (vec2 a) {
		vec4 vx4 = entfr(a.x);
		vec4 vy4 = entfr(a.y);
		vec2 vx2 = herm(vx4.z);
		vec2 vy2 = herm(vy4.z);
		float ret = vx2.y*(vy2.y*ergvecxy(vx4.x,vy4.x,vx4.z,vy4.z) + vy2.x*ergvecxy(vx4.x,vy4.y,vx4.z,vy4.w)) + 
			vx2.x*(vy2.y*ergvecxy(vx4.y,vy4.x,vx4.w,vy4.z)+ vy2.x*ergvecxy(vx4.y,vy4.y,vx4.w,vy4.w));
		return ret;
	}

	float noise2 (vec2 a) {
		float ret = clamp(0.78*(grnoise2(a) + 0.6),0.0,1.0);
		return ret;
	}

	void main() {
		float scaled = inScale/100.0;
		float myX = ((gl_TexCoord[0].s * 2.0) - 1.0) / scaled;
		float myY = ((gl_TexCoord[0].t * 2.0) - 1.0) / scaled;
		float rotX = cos(inRotate)*myX - sin(inRotate)*myY;
		float rotY = sin(inRotate)*myX + cos(inRotate)*myY;
		float myZ = fract(40.0*noise2(vec2(rotX,rotY)));
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = myColor;
	}'
! !

!MyOGLPlayer5 methodsFor: 'pixel shader' stamp: 'daf 8/1/2007 22:27'!
fragNoise4
^'	uniform float inScale;
	uniform float inRotate;
	uniform vec4 inColor1;
	uniform vec4 inColor2;

	float ergvecxy (float fx, float fy, float a, float b) {
		float ix = floor(fx);
		float iy = floor(fy);
		float n = 497.0 + (79.0*ix+12.0) + (37.0*iy-31.0);
		float n2=n*n;
		float ret = (a * float(mod(n*(n2*599479.0+649657.0)+312587137.0,2147483647.0)) +
			b * float(mod(n*(n2*157031.0+789221.0)+1376312589.0,2147483647.0))) / 2147483648.0;
		return ret;
	}

	vec2 herm (float a) {
		float n = a*a*(3.0-2.0*a);
		vec2 ret = vec2(n, 1.0-n);
		return ret;
	}

	vec4 entfr (float a) {
		float n = floor(a);
		float r = a-n;
		vec4 ret = vec4(n,n+1.0,r,r-1.0);
		return ret;
	}

	float grnoise2 (vec2 a) {
		vec4 vx4 = entfr(a.x);
		vec4 vy4 = entfr(a.y);
		vec2 vx2 = herm(vx4.z);
		vec2 vy2 = herm(vy4.z);
		float ret = vx2.y*(vy2.y*ergvecxy(vx4.x,vy4.x,vx4.z,vy4.z) + vy2.x*ergvecxy(vx4.x,vy4.y,vx4.z,vy4.w)) + 
			vx2.x*(vy2.y*ergvecxy(vx4.y,vy4.x,vx4.w,vy4.z)+ vy2.x*ergvecxy(vx4.y,vy4.y,vx4.w,vy4.w));
		return ret;
	}

	void main() {
		float scaled = inScale/100.0;
		float myX = ((gl_TexCoord[0].s * 2.0) - 1.0) / scaled;
		float myY = ((gl_TexCoord[0].t * 2.0) - 1.0) / scaled;
		float rotX = cos(inRotate)*myX - sin(inRotate)*myY;
		float rotY = sin(inRotate)*myX + cos(inRotate)*myY;
		float myZ = 0.0;
		float i;
		for(i=0.0;i<4.0;i++) {
			myZ += pow(0.5,i)*(grnoise2(vec2(rotX/pow(1.87,i),rotY/pow(2.17,i))));
		}
		myZ = abs(fract(myZ));
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = myColor;
	}'
! !

!MyOGLPlayer5 methodsFor: 'pixel shader' stamp: 'daf 8/2/2007 20:24'!
fragNoise5
^'	uniform float inScale;
	uniform float inRotate;
	uniform vec4 inColor1;
	uniform vec4 inColor2;

	float hash(float a) {
		float ret = mod((a+7.0)*(a+3.0),61.0);
		return ret;
	}

	float ergvecxy (float fx, float fy, float a, float b) {
		float ret = hash(a*fx + hash(b*fy));
		return ret;
	}

	vec2 herm (float a) {
		float n = a*a*(3.0-2.0*a);
		vec2 ret = vec2(n, 1.0-n);
		return ret;
	}

	vec4 entfr (float a) {
		float n = floor(a);
		float r = a-n;
		vec4 ret = vec4(n,n+1.0,r,r-1.0);
		return ret;
	}

	float grnoise2 (vec2 a) {
		vec4 vx4 = entfr(a.x);
		vec4 vy4 = entfr(a.y);
		vec2 vx2 = herm(vx4.z);
		vec2 vy2 = herm(vy4.z);
		float ret = vx2.y*(vy2.y*ergvecxy(vx4.x,vy4.x,vx4.z,vy4.z) + vy2.x*ergvecxy(vx4.x,vy4.y,vx4.z,vy4.w)) + 
			vx2.x*(vy2.y*ergvecxy(vx4.y,vy4.x,vx4.w,vy4.z)+ vy2.x*ergvecxy(vx4.y,vy4.y,vx4.w,vy4.w));
		return ret;
	}

	void main() {
		float scaled = inScale/100.0;
		float myX = ((gl_TexCoord[0].s * 2.0) - 1.0) / scaled;
		float myY = ((gl_TexCoord[0].t * 2.0) - 1.0) / scaled;
		float rotX = cos(inRotate)*myX - sin(inRotate)*myY;
		float rotY = sin(inRotate)*myX + cos(inRotate)*myY;
		float myZ = 0.0;
		int i;
		for(i=1;i<=4;i++) {
			myZ += pow(0.5,i)*(grnoise2(vec2(rotX/pow(1.87,i),rotY/pow(2.17,i))));
		}
		myZ = abs(fract(myZ));
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = myColor;
	}'
! !

!MyOGLPlayer5 methodsFor: 'pixel shader' stamp: 'daf 7/28/2007 14:40'!
fragXStripe
^'	uniform float inScale;
	uniform float inRotate;
	uniform vec4 inColor1;
	uniform vec4 inColor2;
	void main() {
		float scaled = inScale/100.0;
		float myX = ((gl_TexCoord[0].s * 2.0) - 1.0) / scaled;
		float myY = ((gl_TexCoord[0].t * 2.0) - 1.0) / scaled;
		float rotX = cos(inRotate)*myX - sin(inRotate)*myY;
		float rotY = sin(inRotate)*myX + cos(inRotate)*myY;
		float myZ = step(0.0, sin(rotX));
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = myColor;
	}'
! !

!MyOGLPlayer5 methodsFor: 'drawing' stamp: 'mtf 1/24/2011 14:22'!
glRenderOn: ogl

	| dx dy scaledLoc rotLoc col1Loc col2Loc |
		dx := bounds width asFloat.
		dy := bounds height asFloat.

	ogl
		glClearColor: color red with:  color green with:  color blue with:  0.0;
		glClear: GLColorBufferBit+GLDepthBufferBit;
		initFrustum: 45.0 bounds: (0@0 extent: dx@dy) zNear: 0.1 zFar: 100.0;

		glShadeModel: GLSmooth;		"Enables Smooth Shading"
		glClearDepth: 1.0;				"Depth Buffer Setup"
		glEnable: GLDepthTest;			"Enables Depth Testing"
		glDepthFunc: GLLequal;			"The Type Of Depth Test To Do"
		glHint: GLPerspectiveCorrectionHint with:  GLNicest;	"Really Nice Perspective Calculations"

		glEnable: GLTexture2d;
		"Linear Filtering"
		glTexParameteri: GLTexture2d with: GLTextureMinFilter with: GLLinear;
		"Linear Filtering"
		glTexParameteri: GLTexture2d with: GLTextureMagFilter with: GLLinear.

		self loadShader: currFrag in: ogl.
		scaledLoc := ogl glGetUniformLocationARB: prog with:  'inScale'.
		ogl glUniform1fARB: scaledLoc with:  self scaleFactor.
		rotLoc := ogl glGetUniformLocationARB: prog with:  'inRotate'.
		ogl glUniform1fARB: rotLoc with:  self rotFactor.
		col1Loc := ogl glGetUniformLocationARB: prog with:  'inColor1'.
		ogl glUniform4fARB: col1Loc with:  col1Factor x with: col1Factor y with: col1Factor z with: col1Factor w.
		col2Loc := ogl glGetUniformLocationARB: prog with:  'inColor2'.
		ogl glUniform4fARB: col2Loc with:  col2Factor x with: col2Factor y with: col2Factor z with: col2Factor w.

	ogl
		glLoadIdentity;					"Reset The View"
		glTranslatef: -1.25 with: 0.0 with: -5.0;		"Move Left And Into The Screen"
		glBegin: GLQuads;				"Start Drawing The square"

		"Front Face"
		"Bottom Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with:  0.0; glVertex3f: -1.0 with:  -1.0 with:  1.0;
		"Bottom Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with:  0.0; glVertex3f:  1.0 with:  -1.0 with:  1.0;
		"Top Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with:  1.0; glVertex3f:  1.0 with:  1.0 with:  1.0;
		"Top Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with:  1.0; glVertex3f: -1.0 with:  1.0 with:  1.0;
		glEnd.							"Done Drawing The Quad"

		ogl glUniform1fARB: scaledLoc with:  (phi/14.4 + 1.0).
		ogl glUniform1fARB: rotLoc with:  (phi/14.4 + 1.0).

	ogl
		glLoadIdentity;
		glTranslatef: 2.0 with: 0.0 with: -7.0;		"Move Right And Into The Screen"
		glRotatef: phi with: 1.0 with: 1.0 with: 1.0;		"Rotate The Cube On X with:  Y & Z"
		glBegin: GLQuads;				"Start Drawing The Cube"

		"Front Face"
		"Bottom Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with:  0.0; glVertex3f: -1.0 with:  -1.0 with:  1.0;
		"Bottom Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with:  0.0; glVertex3f:  1.0 with:  -1.0 with:  1.0;
		"Top Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with:  1.0; glVertex3f:  1.0 with:  1.0 with:  1.0;
		"Top Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with:  1.0; glVertex3f: -1.0 with:  1.0 with:  1.0;
		"Back Face"
		"Bottom Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with:  0.0; glVertex3f: -1.0 with:  -1.0 with:  -1.0;
		"Top Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with:  1.0; glVertex3f: -1.0 with:  1.0 with:  -1.0;
		"Top Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with:  1.0; glVertex3f:  1.0 with:  1.0 with:  -1.0;
		"Bottom Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with:  0.0; glVertex3f:  1.0 with:  -1.0 with:  -1.0;
		"Top Face"
		"Top Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with:  1.0; glVertex3f: -1.0 with:  1.0 with:  -1.0;
		"Bottom Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with:  0.0; glVertex3f: -1.0 with:  1.0 with:  1.0;
		"Bottom Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with:  0.0; glVertex3f:  1.0 with:  1.0 with:  1.0;
		"Top Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with:  1.0; glVertex3f:  1.0 with:  1.0 with:  -1.0;
		"Bottom Face"
		"Top Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with:  1.0; glVertex3f: -1.0 with:  -1.0 with:  -1.0;
		"Top Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with:  1.0; glVertex3f:  1.0 with:  -1.0 with:  -1.0;
		"Bottom Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with:  0.0; glVertex3f:  1.0 with:  -1.0 with:  1.0;
		"Bottom Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with:  0.0; glVertex3f: -1.0 with:  -1.0 with:  1.0;
		"Right face"
		"Bottom Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with:  0.0; glVertex3f:  1.0 with:  -1.0 with:  -1.0;
		"Top Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with:  1.0; glVertex3f:  1.0 with:  1.0 with:  -1.0;
		"Top Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with:  1.0; glVertex3f:  1.0 with:  1.0 with:  1.0;
		"Bottom Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with:  0.0; glVertex3f:  1.0 with:  -1.0 with:  1.0;
		"Left Face"
		"Bottom Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with:  0.0; glVertex3f: -1.0 with:  -1.0 with:  -1.0;
		"Bottom Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with:  0.0; glVertex3f: -1.0 with:  -1.0 with:  1.0;
		"Top Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with:  1.0; glVertex3f: -1.0 with:  1.0 with:  1.0;
		"Top Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with:  1.0; glVertex3f: -1.0 with:  1.0 with:  -1.0;

		glEnd.							"Done Drawing The Quad"

	ogl glUseProgramObjectARB: 0.
! !

!MyOGLPlayer5 methodsFor: 'error handling' stamp: 'daf 7/14/2007 08:20'!
handleError: aString

	"tell somebody about it"
	self signal: #anOGLshaderr with: aString.
! !

!MyOGLPlayer5 methodsFor: 'initialize' stamp: 'daf 7/28/2007 13:59'!
initialize
	super initialize.

	prog := nil.
	reloadFlag := true.
	currFrag := #fragFuzzyChecker.
	scaleFactor := 1.0.
	rotFactor := 0.0.
	col1Factor := Color cyan asVectorColor asVector4.
	col2Factor := Color brown asVectorColor asVector4.
! !

!MyOGLPlayer5 methodsFor: 'drawing' stamp: 'mtf 1/24/2011 14:22'!
loadShader: selector in: ogl
	"Tobias Germer's original comment: Oh - and here is some test code I use
	(in conjunction with Joshuas NullTerminatedStringArray )
	to load some simple GLSL-shaders"
	"Some error checking has been added"

	| vertShader str arr fragShader |

	reloadFlag ifTrue: [
		reloadFlag := false.
		ogl ifNotNil: [
			prog ifNotNil: [
				ogl glDeleteObjectARB: prog.
			prog := nil.
			].
		].
	].

	prog ifNil: [
		self checkForGLSL: ogl.
		vertShader := ogl glCreateShaderObjectARB: GLVertexShaderARB.
		fragShader := ogl glCreateShaderObjectARB: GLFragmentShaderARB.
	
		arr := Array new: 1.
		arr at: 1 put: (CrLfFileStream new convertStringFromCr: self vertSource).
		str := NullTerminatedStringArray withStrings: arr.
		ogl glShaderSourceARB: vertShader with: 1 with: str pointers getHandle with: nil.
		str free.

		arr at: 1 put: (CrLfFileStream new convertStringFromCr: (self perform: selector)).
		str := NullTerminatedStringArray withStrings: arr.
		ogl glShaderSourceARB: fragShader with: 1 with: str pointers getHandle with: nil.
		str free.

		ogl glCompileShaderARB: vertShader.
		self checkCompileForError: vertShader in: ogl.
		ogl glCompileShaderARB: fragShader.
		self checkCompileForError: fragShader in: ogl.

		prog := ogl glCreateProgramObjectARB.
		ogl glAttachObjectARB: prog with: vertShader.
		ogl glAttachObjectARB: prog with: fragShader.

		ogl glLinkProgramARB: prog.
		self checkLinkForError: prog in: ogl.
	].

	ogl glUseProgramObjectARB: prog.
! !

!MyOGLPlayer5 methodsFor: 'events' stamp: 'daf 7/3/2007 16:24'!
onPickedColor1Changed
	<on: pickedColor1Changed>

	col1Factor := pickedColor1 asVectorColor asVector4.
! !

!MyOGLPlayer5 methodsFor: 'events' stamp: 'daf 7/3/2007 16:24'!
onPickedColor2Changed
	<on: pickedColor2Changed>

	col2Factor := pickedColor2 asVectorColor asVector4.
! !

!MyOGLPlayer5 methodsFor: 'events' stamp: 'daf 7/28/2007 14:08'!
onSelectFragChanged
	| |
	<on: selectFragChanged>

	currFrag := selectFrag.
	reloadFlag := true.
	Transcript show: currFrag printString;cr.! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:24'!
pickedColor1
	"Answer the pickedColor1 of the receiver"
	<bewareOf: #pickedColor1Changed>
	^self propertyValueAt: #pickedColor1! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:24'!
pickedColor1: aValue
	"Modify the receiver's pickedColor1"
	^self propertyValueAt: #pickedColor1 put: aValue with: #pickedColor1Changed! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:24'!
pickedColor2
	"Answer the pickedColor2 of the receiver"
	<bewareOf: #pickedColor2Changed>
	^self propertyValueAt: #pickedColor2! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:24'!
pickedColor2: aValue
	"Modify the receiver's pickedColor2"
	^self propertyValueAt: #pickedColor2 put: aValue with: #pickedColor2Changed! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:24'!
prog
	"Answer the prog of the receiver"
	<bewareOf: #progChanged>
	^self propertyValueAt: #prog! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:24'!
prog: aValue
	"Modify the receiver's prog"
	^self propertyValueAt: #prog put: aValue with: #progChanged! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/28/2007 10:29'!
reloadFlag
	"Answer the reloadFlag of the receiver"
	<bewareOf: #reloadFlagChanged>
	^self propertyValueAt: #reloadFlag! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/28/2007 10:29'!
reloadFlag: aValue
	"Modify the receiver's reloadFlag"
	^self propertyValueAt: #reloadFlag put: aValue with: #reloadFlagChanged! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:25'!
rotFactor
	"Answer the rotFactor of the receiver"
	<bewareOf: #rotFactorChanged>
	^self propertyValueAt: #rotFactor! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:25'!
rotFactor: aValue
	"Modify the receiver's rotFactor"
	^self propertyValueAt: #rotFactor put: aValue with: #rotFactorChanged! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:24'!
scaleFactor
	"Answer the scaleFactor of the receiver"
	<bewareOf: #scaleFactorChanged>
	^self propertyValueAt: #scaleFactor! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/3/2007 16:24'!
scaleFactor: aValue
	"Modify the receiver's scaleFactor"
	^self propertyValueAt: #scaleFactor put: aValue with: #scaleFactorChanged! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/21/2007 11:10'!
selectFrag
	"Answer the selectFrag of the receiver"
	<bewareOf: #selectFragChanged>
	^self propertyValueAt: #selectFrag! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/21/2007 11:10'!
selectFrag: aValue
	"Modify the receiver's selectFrag"
	^self propertyValueAt: #selectFrag put: aValue with: #selectFragChanged! !

!MyOGLPlayer5 methodsFor: 'accessing' stamp: 'daf 7/28/2007 10:27'!
selectors4Frags
	"Anwer a list of selectors that are fragment(pixel) shaders"
	"Note that this is entirely dependent on method/selector naming convention"

	| aList |
	aList := self class selectors select:
		[:aSelector | (aSelector beginsWith: 'frag')].

	^ aList asSortedArray! !

!MyOGLPlayer5 methodsFor: 'error handling' stamp: 'mtf 1/24/2011 14:23'!
showlog: anObj in: ogl
	"Get the OGL info log entry and show it."
	| length infoLog |

	length := IntegerArray new: 1.
	ogl glGetObjectParameterivARB: anObj with: GLObjectInfoLogLengthARB with: length.
	infoLog := ByteArray new: (length first).
	ogl glGetInfoLogARB: anObj with: (length first) with: nil with: infoLog.
	self handleError: (infoLog asString copyReplaceAll: ':' with: '\') withCRs.
! !

!MyOGLPlayer5 methodsFor: 'vertex shader' stamp: 'daf 7/3/2007 16:24'!
vertSource
^'	void main() {
		gl_Position = ftransform();
		gl_TexCoord[0]  = gl_MultiTexCoord0;
	}'
! !

COpenGLPlayer subclass: #MyOGLPlayer6
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-OpenGL'!

!MyOGLPlayer6 commentStamp: '<historical>' prior: 0!
Tweak player for OpenGL with GLSL for Wrinkle2!

MyOGLPlayer6 defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="prog" toSet="prog:" changeEvent="progChanged">prog</field>
	<field toGet="fbo" toSet="fbo:" changeEvent="fboChanged">fbo</field>
	<field toGet="depthBuffer" toSet="depthBuffer:" changeEvent="depthBufferChanged">depthBuffer</field>
	<field toGet="img" toSet="img:" changeEvent="imgChanged">img</field>
	<field toGet="mix1Factor" toSet="mix1Factor:" changeEvent="mix1FactorChanged">mix1Factor</field>
	<field toGet="scale1Factor" toSet="scale1Factor:" changeEvent="scale1FactorChanged">scale1Factor</field>
	<field toGet="rot1Factor" toSet="rot1Factor:" changeEvent="rot1FactorChanged">rot1Factor</field>
	<field toGet="mix2Factor" toSet="mix2Factor:" changeEvent="mix2FactorChanged">mix2Factor</field>
	<field toGet="scale2Factor" toSet="scale2Factor:" changeEvent="scale2FactorChanged">scale2Factor</field>
	<field toGet="rot2Factor" toSet="rot2Factor:" changeEvent="rot2FactorChanged">rot2Factor</field>
	<field toGet="col1Factor1" toSet="col1Factor1:" changeEvent="col1Factor1Changed">col1Factor1</field>
	<field toGet="col1Factor2" toSet="col1Factor2:" changeEvent="col1Factor2Changed">col1Factor2</field>
	<field toGet="col2Factor1" toSet="col2Factor1:" changeEvent="col2Factor1Changed">col2Factor1</field>
	<field toGet="col2Factor2" toSet="col2Factor2:" changeEvent="col2Factor2Changed">col2Factor2</field>
	<field toGet="picked1Color1" toSet="picked1Color1:" changeEvent="picked1Color1Changed">picked1Color1</field>
	<field toGet="picked1Color2" toSet="picked1Color2:" changeEvent="picked1Color2Changed">picked1Color2</field>
	<field toGet="picked2Color1" toSet="picked2Color1:" changeEvent="picked2Color1Changed">picked2Color1</field>
	<field toGet="picked2Color2" toSet="picked2Color2:" changeEvent="picked2Color2Changed">picked2Color2</field>
	<field toGet="curr1Frag" toSet="curr1Frag:" changeEvent="curr1FragChanged">curr1Frag</field>
	<field toGet="select1Frag" toSet="select1Frag:" changeEvent="select1FragChanged">select1Frag</field>
	<field toGet="curr2Frag" toSet="curr2Frag:" changeEvent="curr2FragChanged">curr2Frag</field>
	<field toGet="select2Frag" toSet="select2Frag:" changeEvent="select2FragChanged">select2Frag</field>
	<field toGet="reloadFlag" toSet="reloadFlag:" changeEvent="reloadFlagChanged">reloadFlag</field>
	<field toGet="saveFlag" toSet="saveFlag:" changeEvent="saveFlagChanged">saveFlag</field>
	<field toGet="savedForm" toSet="savedForm:" changeEvent="savedFormChanged">savedForm</field>
</fields>'!

!MyOGLPlayer6 methodsFor: 'error handling' stamp: 'mtf 1/24/2011 14:23'!
checkCompileForError: anObj in: ogl
	"Check for any GLSL compile errors"
	| status |

	status := IntegerArray new: 1.
	ogl glGetObjectParameterivARB: anObj with: GLObjectCompileStatusARB with: status.
	((status first) = GLTrue) ifFalse: [self showlog: anObj in: ogl]
! !

!MyOGLPlayer6 methodsFor: 'error handling' stamp: 'daf 8/2/2007 21:16'!
checkForError: ogl
	"Check for any OpenGL errors"
	| status |

	status := ogl glGetError.
	(status = GLNoError) ifFalse: [self handleError: status printString]
! !

!MyOGLPlayer6 methodsFor: 'error handling' stamp: 'daf 8/12/2007 14:50'!
checkForFBO: ogl
	"Check for FBO support"
	"this is a pretty minimal check"
	| status |

	status := ogl extensions includes: #'GL_EXT_framebuffer_object'.
	status ifFalse:  [ self handleError: 'FBO is not supported\Try running:\GPUInfo new chkGLSLSupport' withCRs. ]
! !

!MyOGLPlayer6 methodsFor: 'error handling' stamp: 'daf 8/2/2007 21:17'!
checkForGLSL: ogl
	"Check for GLSL support"
	"this is a pretty minimal check"
	| status |

	status := ogl extensions includes: #'GL_ARB_shading_language_100'.
	status ifFalse:  [ self handleError: 'GLSL is not supported\Try running:\GPUInfo new chkGLSLSupport' withCRs. ]
! !

!MyOGLPlayer6 methodsFor: 'error handling' stamp: 'mtf 1/24/2011 14:24'!
checkLinkForError: anObj in: ogl
	"Check for any GLSL link errors"
	| status |

	status := IntegerArray new: 1.
	ogl glGetObjectParameterivARB: anObj with: GLObjectLinkStatusARB with: status.
	((status first) = GLTrue) ifFalse: [self showlog: anObj in: ogl]
! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
col1Factor1
	"Answer the col1Factor1 of the receiver"
	<bewareOf: #col1Factor1Changed>
	^self propertyValueAt: #col1Factor1! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
col1Factor1: aValue
	"Modify the receiver's col1Factor1"
	^self propertyValueAt: #col1Factor1 put: aValue with: #col1Factor1Changed! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
col1Factor2
	"Answer the col1Factor2 of the receiver"
	<bewareOf: #col1Factor2Changed>
	^self propertyValueAt: #col1Factor2! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
col1Factor2: aValue
	"Modify the receiver's col1Factor2"
	^self propertyValueAt: #col1Factor2 put: aValue with: #col1Factor2Changed! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
col2Factor1
	"Answer the col2Factor1 of the receiver"
	<bewareOf: #col2Factor1Changed>
	^self propertyValueAt: #col2Factor1! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
col2Factor1: aValue
	"Modify the receiver's col2Factor1"
	^self propertyValueAt: #col2Factor1 put: aValue with: #col2Factor1Changed! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
col2Factor2
	"Answer the col2Factor2 of the receiver"
	<bewareOf: #col2Factor2Changed>
	^self propertyValueAt: #col2Factor2! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
col2Factor2: aValue
	"Modify the receiver's col2Factor2"
	^self propertyValueAt: #col2Factor2 put: aValue with: #col2Factor2Changed! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
curr1Frag
	"Answer the curr1Frag of the receiver"
	<bewareOf: #curr1FragChanged>
	^self propertyValueAt: #curr1Frag! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
curr1Frag: aValue
	"Modify the receiver's curr1Frag"
	^self propertyValueAt: #curr1Frag put: aValue with: #curr1FragChanged! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
curr2Frag
	"Answer the curr2Frag of the receiver"
	<bewareOf: #curr2FragChanged>
	^self propertyValueAt: #curr2Frag! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
curr2Frag: aValue
	"Modify the receiver's curr2Frag"
	^self propertyValueAt: #curr2Frag put: aValue with: #curr2FragChanged! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/12/2007 14:13'!
depthBuffer
	"Answer the depthBuffer of the receiver"
	<bewareOf: #depthBufferChanged>
	^self propertyValueAt: #depthBuffer! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/12/2007 14:13'!
depthBuffer: aValue
	"Modify the receiver's depthBuffer"
	^self propertyValueAt: #depthBuffer put: aValue with: #depthBufferChanged! !

!MyOGLPlayer6 methodsFor: 'drawing' stamp: 'mtf 1/24/2011 14:25'!
destroyGl
	opengl ifNotNil: [
		prog ifNotNil: [
			opengl glDeleteObjectARB: prog.
			prog := nil.
		].
		fbo ifNotNil: [
			opengl glDeleteFramebuffersEXT: 1 with: (IntegerArray with: fbo).
			opengl glDeleteRenderbuffersEXT: 1 with: (IntegerArray with: depthBuffer).
			opengl glDeleteTextures: 1 with: (IntegerArray with: img).
			fbo := nil.
			depthBuffer := nil.
			img := nil.
		].
		opengl destroy. 
		opengl := nil.
	]! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/12/2007 14:13'!
fbo
	"Answer the fbo of the receiver"
	<bewareOf: #fboChanged>
	^self propertyValueAt: #fbo! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/12/2007 14:13'!
fbo: aValue
	"Modify the receiver's fbo"
	^self propertyValueAt: #fbo put: aValue with: #fboChanged! !

!MyOGLPlayer6 methodsFor: 'pixel shader' stamp: 'daf 8/23/2007 20:34'!
frHead
^'#version 110
	uniform float in1Mix;
	uniform float in1Scale;
	uniform float in1Rotate;
	uniform vec4 in1Color1;
	uniform vec4 in1Color2;

	uniform float in2Mix;
	uniform float in2Scale;
	uniform float in2Rotate;
	uniform vec4 in2Color1;
	uniform vec4 in2Color2;

	/* this function does a standard setup from the Tweak UI */
	vec2 frSetup(float inScale, float scaledBy, float inRotate) {
		float scaled = inScale/scaledBy;
		float myX = ((gl_TexCoord[0].s * 2.0) - 1.0) / scaled;
		float myY = ((gl_TexCoord[0].t * 2.0) - 1.0) / scaled;
		float rotX = cos(inRotate)*myX - sin(inRotate)*myY;
		float rotY = sin(inRotate)*myX + cos(inRotate)*myY;
		vec2 ret = vec2(rotX,rotY);
		return ret;
	}

	/* these functions are from a Lumina noise tutorial */
	float lumRand1(vec2 co){
		return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
	}

	float lum1Noise(vec2 co){
		return lumRand1(floor(co * 128.0));
	}

	vec4 lumRand4(vec2 A,vec2 B,vec2 C,vec2 D){
		vec2 s = vec2 (12.9898,78.233);
		vec4 tmp = vec4( dot(A,s),dot(B,s),dot(C,s),dot(D,s));
		return fract(tan(tmp)  * 43758.5453);
	}

	float lum2Noise(vec2 coord,float d){
		vec2 C[4];
		C[0] = floor( coord * d)/d ;
		C[1] = C[0] + vec2(1.0/d ,0.0  );
		C[2] = C[0] + vec2(1.0/d ,1.0/d);
		C[3] = C[0] + vec2(0.0   ,1.0/d);
		vec2 p = fract(coord * d);
		vec2 q = 1.0 - p;
		vec4 w = vec4(q.x * q.y, p.x * q.y, p.x * p.y, q.x * p.y);
		return dot(vec4(lumRand4(C[0],C[1],C[2],C[3])),w);
	}

	/* these functions are based on parts of Clastic */
	float symteeth(float a) {
		float ret = abs(2.0*fract(a+0.5)-1.0);
		return ret;
	}

	float xpulse(float a, float b, float c) {
		float ret;
		if (c<a || c>b) { ret = 0.0; }
		else {
			if (c>a && c<b) { ret = 1.0; }
			else { ret = 0.5; }
		}
		return ret;
	}
'! !

!MyOGLPlayer6 methodsFor: 'pixel shader' stamp: 'daf 8/5/2007 15:14'!
frTail
^'
	void main() {
		gl_FragColor = gl_Color;
		', curr1Frag, '(in1Scale, in1Rotate, in1Color1, in1Color2, in1Mix);		
		', curr2Frag, '(in2Scale, in2Rotate, in2Color1, in2Color2, in2Mix);		
	}'
! !

!MyOGLPlayer6 methodsFor: 'pixel shader' stamp: 'daf 8/10/2007 19:31'!
fragChecker
^'
#ifndef FRAGCHECKER
	void fragChecker(float inScale, float inRotate, vec4 inColor1, vec4 inColor2, float inMix) {
		vec2 xyRot = frSetup(inScale,100.0,inRotate);
		float myZ = step(0.0, sin(xyRot.x) * cos(xyRot.y));
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = mix(gl_FragColor,myColor,inMix);
	}
#define FRAGCHECKER 1
#endif
'
! !

!MyOGLPlayer6 methodsFor: 'pixel shader' stamp: 'daf 8/5/2007 09:06'!
fragError
^'
	void fragError {
		There must be a compile error in here somewhere;
	}
'
! !

!MyOGLPlayer6 methodsFor: 'pixel shader' stamp: 'daf 8/10/2007 19:41'!
fragExample0
^'
#ifndef FRAGEXAMPLE0
	void fragExample0(float inScale, float inRotate, vec4 inColor1, vec4 inColor2, float inMix) {
		vec2 xyRot = frSetup(inScale,100.0,inRotate);
		float myZ = sin(xyRot.x+sin(xyRot.y+sin(xyRot.x))) - sin(xyRot.y+sin(xyRot.x+sin(xyRot.y)));
		myZ = (fract(myZ) + 1.0) / 2.0;
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = mix(gl_FragColor,myColor,inMix);
	}
#define FRAGEXAMPLE0 1
#endif
'
! !

!MyOGLPlayer6 methodsFor: 'pixel shader' stamp: 'daf 8/10/2007 19:36'!
fragFuzzyChecker
^'
#ifndef FRAGFUZZYCHECKER
	void fragFuzzyChecker(float inScale, float inRotate, vec4 inColor1, vec4 inColor2, float inMix) {
		vec2 xyRot = frSetup(inScale,100.0,inRotate);
		float myZ = smoothstep(-0.5, 0.5, sin(xyRot.x) * cos(xyRot.y));
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = mix(gl_FragColor,myColor,inMix);
	}
#define FRAGFUZZYCHECKER 1
#endif
'
! !

!MyOGLPlayer6 methodsFor: 'pixel shader' stamp: 'daf 8/10/2007 19:41'!
fragHexagon
^'
#ifndef FRAGHEXAGON
	void fragHexagon(float inScale, float inRotate, vec4 inColor1, vec4 inColor2, float inMix) {
		vec2 xyRot = frSetup(inScale,100.0,inRotate);
		float myZ = symteeth(2.0*xyRot.x) +
					symteeth(xyRot.x+sqrt(3.0)*xyRot.y) +
					symteeth(xyRot.x-sqrt(3.0)*xyRot.y) - 1.5;
		myZ = step(0.0,myZ);
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = mix(gl_FragColor,myColor,inMix);
	}
#define FRAGHEXAGON 1
#endif
'
! !

!MyOGLPlayer6 methodsFor: 'pixel shader' stamp: 'daf 8/11/2007 09:45'!
fragNoise1
^'
#ifndef FRAGNOISE1
	void fragNoise1(float inScale, float inRotate, vec4 inColor1, vec4 inColor2, float inMix) {
		vec2 xyRot = frSetup(inScale,1.0,inRotate);
		float myZ = lum1Noise(xyRot);
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = mix(gl_FragColor,myColor,inMix);
	}
#define FRAGNOISE1 1
#endif
'
! !

!MyOGLPlayer6 methodsFor: 'pixel shader' stamp: 'daf 8/11/2007 09:51'!
fragNoise2
^'
#ifndef FRAGNOISE2
	void fragNoise2(float inScale, float inRotate, vec4 inColor1, vec4 inColor2, float inMix) {
		vec2 xyRot = frSetup(inScale,1.0,inRotate);
		float myZ = lum2Noise(xyRot,128.0 );
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = mix(gl_FragColor,myColor,inMix);
	}
#define FRAGNOISE2 1
#endif
'
! !

!MyOGLPlayer6 methodsFor: 'pixel shader' stamp: 'daf 8/11/2007 10:00'!
fragNoise3
^'
#ifndef FRAGNOISE3
	void fragNoise3(float inScale, float inRotate, vec4 inColor1, vec4 inColor2, float inMix) {
		vec2 xyRot = frSetup(inScale,1.0,inRotate);
		float myZ = abs(fract(7.0*(lum2Noise(xyRot,128.0))));
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = mix(gl_FragColor,myColor,inMix);
	}
#define FRAGNOISE3 1
#endif
'
! !

!MyOGLPlayer6 methodsFor: 'pixel shader' stamp: 'daf 8/10/2007 20:19'!
fragNoise4
^'
#ifndef FRAGNOISE4
	void fragNoise4(float inScale, float inRotate, vec4 inColor1, vec4 inColor2, float inMix) {
		vec2 xyRot = frSetup(inScale,1.0,inRotate);
		float myZ = 0.0;
		float i;
		for(i=0.0;i<4.0;i++) {
			myZ += pow(0.5,i)*(lum2Noise(vec2(xyRot.x/pow(1.87,i),xyRot.y/pow(2.17,i)),128.0));
		}
		myZ = abs(fract(myZ));
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = mix(gl_FragColor,myColor,inMix);
	}
#define FRAGNOISE4 1
#endif
'
! !

!MyOGLPlayer6 methodsFor: 'pixel shader' stamp: 'daf 8/23/2007 20:33'!
fragTruchet
^'
#ifndef FRAGTRUCHET
	void fragTruchet(float inScale, float inRotate, vec4 inColor1, vec4 inColor2, float inMix) {
		vec2 xyRot = frSetup(inScale,100.0,inRotate);
		float myZ = lum1Noise(vec2(floor(xyRot.x),floor(xyRot.y)));
		float newX = fract(xyRot.x);
		float newY = fract(xyRot.y);
		if (myZ > 0.5) { newX = 1.0 - newX; }
		myZ = xpulse(0.15, 0.35, newX*newX+newY*newY);
		newX = 1.0 - newX;
		newY = 1.0 - newY;
		myZ += xpulse(0.15, 0.35, newX*newX+newY*newY);
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = mix(gl_FragColor,myColor,inMix);
	}
#define FRAGTRUCHET 1
#endif
'
! !

!MyOGLPlayer6 methodsFor: 'pixel shader' stamp: 'daf 8/10/2007 19:41'!
fragXStripe
^'
#ifndef FRAGXSTRIPE
	void fragXStripe(float inScale, float inRotate, vec4 inColor1, vec4 inColor2, float inMix) {
		vec2 xyRot = frSetup(inScale,100.0,inRotate);
		float myZ = step(0.0, sin(xyRot.x));
		vec4 myColor = mix(inColor1,inColor2,myZ);
		gl_FragColor = mix(gl_FragColor,myColor,inMix);
	}
#define FRAGXSTRIPE 1
#endif
'
! !

!MyOGLPlayer6 methodsFor: 'drawing' stamp: 'daf 8/5/2007 08:20'!
gatherFrags
	^ (self frHead), (self perform: curr1Frag), (self perform: curr2Frag), (self frTail)! !

!MyOGLPlayer6 methodsFor: 'drawing' stamp: 'mtf 1/24/2011 14:28'!
glRenderOn: ogl

	| dx dy fboWidth fboHeight mix1Loc scaled1Loc rot1Loc col1Loc1 col2Loc1 mix2Loc scaled2Loc rot2Loc col1Loc2 col2Loc2 status stStep stVal |
		dx := bounds width asFloat.
		dy := bounds height asFloat.

		fboWidth := 128.0.
		fboHeight := 128.0.
		stStep := 1.0.
		stVal := 1.0.

	ogl
		glShadeModel: GLSmooth;		"Enables Smooth Shading"
		glClearDepth: 1.0;				"Depth Buffer Setup"
		glEnable: GLDepthTest;			"Enables Depth Testing"
		glDepthFunc: GLLequal;			"The Type Of Depth Test To Do"
		glHint: GLPerspectiveCorrectionHint with: GLNicest;	"Really Nice Perspective Calculations"

		glEnable: GLTexture2d.

		self initFboIn: ogl extent: fboWidth@fboHeight.

	ogl	glClearColor: 0.0 with: 0.3 with: 0.0 with: 1.0;
		glClear: GLColorBufferBit+GLDepthBufferBit;
		initFrustum: 45.0 bounds: (0@0 extent: fboWidth@fboHeight) zNear: 0.1 zFar: 100.0.

		status := self loadShadersIn: ogl.
		status ifTrue: [
			mix1Loc := ogl glGetUniformLocationARB: prog with: 'in1Mix'.
			ogl glUniform1fARB: mix1Loc with: self mix1Factor.
			scaled1Loc := ogl glGetUniformLocationARB: prog with: 'in1Scale'.
			ogl glUniform1fARB: scaled1Loc with: self scale1Factor.
			rot1Loc := ogl glGetUniformLocationARB: prog with: 'in1Rotate'.
			ogl glUniform1fARB: rot1Loc with: self rot1Factor.
			col1Loc1 := ogl glGetUniformLocationARB: prog with: 'in1Color1'.
			ogl glUniform4fARB: col1Loc1 with: col1Factor1 x with: col1Factor1 y with: col1Factor1 z with: col1Factor1 w.
			col2Loc1 := ogl glGetUniformLocationARB: prog with: 'in1Color2'.
			ogl glUniform4fARB: col2Loc1 with: col2Factor1 x with: col2Factor1 y with: col2Factor1 z with: col2Factor1 w.

			mix2Loc := ogl glGetUniformLocationARB: prog with: 'in2Mix'.
			ogl glUniform1fARB: mix2Loc with: self mix2Factor.
			scaled2Loc := ogl glGetUniformLocationARB: prog with: 'in2Scale'.
			ogl glUniform1fARB: scaled2Loc with: self scale2Factor.
			rot2Loc := ogl glGetUniformLocationARB: prog with: 'in2Rotate'.
			ogl glUniform1fARB: rot2Loc with: self rot2Factor.
			col1Loc2 := ogl glGetUniformLocationARB: prog with: 'in2Color1'.
			ogl glUniform4fARB: col1Loc2 with: col1Factor2 x with: col1Factor2 y with: col1Factor2 z with: col1Factor2 w.
			col2Loc2 := ogl glGetUniformLocationARB: prog with: 'in2Color2'.
			ogl glUniform4fARB: col2Loc2 with: col2Factor2 x with: col2Factor2 y with: col2Factor2 z with: col2Factor2 w.
		].

	ogl
		glLoadIdentity;					"Reset The View"
		glTranslatef: 0.0 with: 0.0 with: -2.0;		"Move Into The Screen"
		glBegin: GLQuads;				"Start Drawing The square"

		"Front Face"
		"Bottom Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with: 0.0; glVertex3f: -1.0 with: -1.0 with: 1.0;
		"Bottom Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with: 0.0; glVertex3f:  1.0 with: -1.0 with: 1.0;
		"Top Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with: 1.0; glVertex3f:  1.0 with: 1.0 with: 1.0;
		"Top Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with: 1.0; glVertex3f: -1.0 with: 1.0 with: 1.0;
		glEnd.							"Done Drawing The Quad"

	saveFlag ifTrue: [
		"glGetpixels into a form"
		savedForm := Form extent: fboWidth@fboHeight depth: 32.
		ogl glReadPixels: 
				0 with: 0 with: 
				fboWidth with: fboHeight with: 
				ogl texturePixelFormat with: ogl texturePixelType with: 
				savedForm bits. 

		"signal form gotten so Tweak UI can pick it up"
		self signal: #anOGLtex2form.
		saveFlag := false.
	].

	ogl
		glBindFramebufferEXT: GLFramebufferEXT with: 0;
		glUseProgramObjectARB: 0;

		glClearColor: 0.2 with: 0.0 with: 0.0 with: 1.0;
		glClear: GLColorBufferBit+GLDepthBufferBit;
		initFrustum: 45.0 bounds: (0@0 extent: dx@dy) zNear: 0.1 zFar: 100.0;

		glLoadIdentity;					"Reset The View"
		"Now bind the texture to use it"
		glEnable: GLTexture2d;
		glBindTexture: GLTexture2d with: img;

		"If you enabled the mipmap filtering on setup earlier then you'll need to uncomment the line
		below so OpenGL can generate all the mipmap data for the new main image each frame"
		"glGenerateMipmapEXT: GLTexture2d;"

		glTranslatef: -1.25 with: 0.0 with: -5.0;		"Move Left And Into The Screen"
		glBegin: GLQuads;				"Start Drawing The square"

		"Front Face"
		"Bottom Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with: 0.0; glVertex3f: -1.0 with: -1.0 with: 1.0;
		"Bottom Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with: 0.0; glVertex3f:  1.0 with: -1.0 with: 1.0;
		"Top Right Of The Texture and Quad"
		glTexCoord2f: 1.0 with: 1.0; glVertex3f:  1.0 with: 1.0 with: 1.0;
		"Top Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with: 1.0; glVertex3f: -1.0 with: 1.0 with: 1.0;
		glEnd.							"Done Drawing The Quad"

	ogl
		glLoadIdentity;
		glTranslatef: 2.0 with: 0.0 with: -7.0;		"Move Right And Into The Screen"
		glRotatef: phi with: 1.0 with: 1.0 with: 1.0;		"Rotate The Cube On X with: Y & Z"
		glBegin: GLQuads;				"Start Drawing The Cube"

		"Front Face"
		"Bottom Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with: 0.0; glVertex3f: -1.0 with: -1.0 with: 1.0;
		"Bottom Right Of The Texture and Quad"
		glTexCoord2f: stVal with: 0.0; glVertex3f:  1.0 with: -1.0 with: 1.0;
		"Top Right Of The Texture and Quad"
		glTexCoord2f: stVal with: stVal; glVertex3f:  1.0 with: 1.0 with: 1.0;
		"Top Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with: stVal; glVertex3f: -1.0 with: 1.0 with: 1.0.
		"Back Face"
		"Bottom Right Of The Texture and Quad"
	ogl	glTexCoord2f: stVal with: 0.0; glVertex3f: -1.0 with: -1.0 with: -1.0;
		"Top Right Of The Texture and Quad"
		glTexCoord2f: stVal with: stVal; glVertex3f: -1.0 with: 1.0 with: -1.0;
		"Top Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with: stVal; glVertex3f:  1.0 with: 1.0 with: -1.0;
		"Bottom Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with: 0.0; glVertex3f:  1.0 with: -1.0 with: -1.0.
		"Top Face"
		stVal := stVal + stStep.
		"Top Left Of The Texture and Quad"
	ogl	glTexCoord2f: 0.0 with: stVal; glVertex3f: -1.0 with: 1.0 with: -1.0;
		"Bottom Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with: 0.0; glVertex3f: -1.0 with: 1.0 with: 1.0;
		"Bottom Right Of The Texture and Quad"
		glTexCoord2f: stVal with: 0.0; glVertex3f:  1.0 with: 1.0 with: 1.0;
		"Top Right Of The Texture and Quad"
		glTexCoord2f: stVal with: stVal; glVertex3f:  1.0 with: 1.0 with: -1.0.
		"Bottom Face"
		"Top Right Of The Texture and Quad"
	ogl	glTexCoord2f: stVal with: stVal; glVertex3f: -1.0 with: -1.0 with: -1.0;
		"Top Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with: stVal; glVertex3f:  1.0 with: -1.0 with: -1.0;
		"Bottom Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with: 0.0; glVertex3f:  1.0 with: -1.0 with: 1.0;
		"Bottom Right Of The Texture and Quad"
		glTexCoord2f: stVal with: 0.0; glVertex3f: -1.0 with: -1.0 with: 1.0.
		"Right face"
		stVal := stVal + stStep.
		"Bottom Right Of The Texture and Quad"
	ogl	glTexCoord2f: stVal with: 0.0; glVertex3f:  1.0 with: -1.0 with: -1.0;
		"Top Right Of The Texture and Quad"
		glTexCoord2f: stVal with: stVal; glVertex3f:  1.0 with: 1.0 with: -1.0;
		"Top Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with: stVal; glVertex3f:  1.0 with: 1.0 with: 1.0;
		"Bottom Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with: 0.0; glVertex3f:  1.0 with: -1.0 with: 1.0.
		"Left Face"
		"Bottom Left Of The Texture and Quad"
	ogl	glTexCoord2f: 0.0 with: 0.0; glVertex3f: -1.0 with: -1.0 with: -1.0;
		"Bottom Right Of The Texture and Quad"
		glTexCoord2f: stVal with: 0.0; glVertex3f: -1.0 with: -1.0 with: 1.0;
		"Top Right Of The Texture and Quad"
		glTexCoord2f: stVal with: stVal; glVertex3f: -1.0 with: 1.0 with: 1.0;
		"Top Left Of The Texture and Quad"
		glTexCoord2f: 0.0 with: stVal; glVertex3f: -1.0 with: 1.0 with: -1.0;

		glEnd.							"Done Drawing The Quad"

	ogl	glBindTexture: GLTexture2d with: 0.		"unbind the texture"
! !

!MyOGLPlayer6 methodsFor: 'error handling' stamp: 'daf 8/2/2007 21:17'!
handleError: aString

	"tell somebody about it"
	self signal: #anOGLshaderr with: aString.
! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/12/2007 14:13'!
img
	"Answer the img of the receiver"
	<bewareOf: #imgChanged>
	^self propertyValueAt: #img! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/12/2007 14:14'!
img: aValue
	"Modify the receiver's img"
	^self propertyValueAt: #img put: aValue with: #imgChanged! !

!MyOGLPlayer6 methodsFor: 'drawing' stamp: 'mtf 1/24/2011 14:32'!
initFboIn: ogl extent: fboExtent
	"initialize an OGL FrameBuffer object"

	"based on the FBO Example Project Overview by Rob 'phantom' Jones which is (c)2006 Rob Jones.
	 Rob says 'Feel free to reuse as you see fit, just don't claim credit :)' "

	| status fboWidth fboHeight |

	(fbo isNil) ifTrue: [
		self checkForFBO: ogl.

		fboWidth := fboExtent x.
		fboHeight := fboExtent y.

		"Setup our FBO"
		status := IntegerArray new: 1.
		ogl glGenFramebuffersEXT: 1 with: status.
		fbo := status first.
		ogl glBindFramebufferEXT: GLFramebufferEXT with: fbo.

		"Create the render buffer for depth"
		status := IntegerArray new: 1.
		ogl glGenRenderbuffersEXT: 1 with: status.
		depthBuffer := status first.
		ogl glBindRenderbufferEXT: GLRenderbufferEXT with: depthBuffer.
		ogl glRenderbufferStorageEXT: GLRenderbufferEXT with: GLDepthComponent with: fboWidth with: fboHeight.

		"Now setup a texture to render to"
		status := IntegerArray new: 1.
		ogl glGenTextures: 1 with: status.
		img := status first.
		ogl glBindTexture: GLTexture2d with: img;
			glTexImage2D:GLTexture2d with:0 with:GLRgba8 with:fboWidth with:fboHeight with:0 with:GLRgba with:GLUnsignedByte with:nil ;
		"	glTexParameteri: GLTexture2d with: GLTextureWrapS with: GLClampToEdge;
			glTexParameteri: GLTexture2d with: GLTextureWrapT with: GLClampToEdge; "
			glTexParameteri: GLTexture2d with: GLTextureMagFilter with: GLLinear;
			glTexParameteri: GLTexture2d with: GLTextureMinFilter with: GLLinear.

	"	The following 3 lines enable mipmap filtering and generate the mipmap data so rendering works
		ogl glTexParameteri: GLTexture2d with: GLTextureMagFilter with: GLLinear.
		ogl glTexParameteri: GLTexture2d with: GLTextureMinFilter with: GLLinearMipmapLinear."
		"ogl glGenerateMipmapEXT: GLTexture2d."

		"And attach it to the FBO so we can render to it"
		ogl glFramebufferTexture2DEXT: GLFramebufferEXT with: GLColorAttachment0EXT with: GLTexture2d with: img with: 0.

		"Attach the depth render buffer to the FBO as it's depth attachment"
		ogl glFramebufferRenderbufferEXT: GLFramebufferEXT with: GLDepthAttachmentEXT with: GLRenderbufferEXT with: depthBuffer.

		status := ogl glCheckFramebufferStatusEXT: GLFramebufferEXT.
		(status = GLFramebufferCompleteEXT) ifFalse: [ self handleError: 'FBO not complete, status=0x',(status printStringBase: 16) ].
	] ifFalse: [
		ogl glBindFramebufferEXT: GLFramebufferEXT with: fbo.
	].
! !

!MyOGLPlayer6 methodsFor: 'initialize' stamp: 'daf 8/18/2007 09:32'!
initialize
	super initialize.

	prog := nil.
	reloadFlag := true.
	fbo := nil.
	saveFlag := false.

	mix1Factor := 1.0.
	curr1Frag := #fragFuzzyChecker.
	scale1Factor := 1.0.
	rot1Factor := 0.0.
	col1Factor1 := Color cyan asVectorColor asVector4.
	col2Factor1 := Color brown asVectorColor asVector4.

	mix2Factor := 0.0.
	curr2Frag := #fragXStripe.
	scale2Factor := 1.0.
	rot2Factor := 0.0.
	col1Factor2 := Color green asVectorColor asVector4.
	col2Factor2 := Color black asVectorColor asVector4.
! !

!MyOGLPlayer6 methodsFor: 'drawing' stamp: 'mtf 1/24/2011 14:32'!
loadShadersIn: ogl
	"load multiple cascaded shaders into a single source prog"

	| vertShader str arr fragShader status |

	reloadFlag ifTrue: [
		reloadFlag := false.
		ogl ifNotNil: [
			prog ifNotNil: [
				ogl glDeleteObjectARB: prog.
			prog := nil.
			].
		].
	].

	prog ifNil: [
		self checkForGLSL: ogl.
		vertShader := ogl glCreateShaderObjectARB: GLVertexShaderARB.
		fragShader := ogl glCreateShaderObjectARB: GLFragmentShaderARB.
	
		arr := Array new: 1.
		arr at: 1 put: (CrLfFileStream new convertStringFromCr: self vertSource).
		str := NullTerminatedStringArray withStrings: arr.
		ogl glShaderSourceARB: vertShader with: 1 with: str pointers getHandle with: nil.
		str free.

		arr at: 1 put: (CrLfFileStream new convertStringFromCr: self gatherFrags).
		str := NullTerminatedStringArray withStrings: arr.
"Transcript show: arr printString."
		ogl glShaderSourceARB: fragShader with: 1 with: str pointers getHandle with: nil.
		str free.

		ogl glCompileShaderARB: vertShader.
		self checkCompileForError: vertShader in: ogl.
		ogl glCompileShaderARB: fragShader.
		self checkCompileForError: fragShader in: ogl.

		prog := ogl glCreateProgramObjectARB.
		ogl glAttachObjectARB: prog with: vertShader.
		ogl glAttachObjectARB: prog with: fragShader.

		ogl glLinkProgramARB: prog.
		self checkLinkForError: prog in: ogl.
	].

	ogl glUseProgramObjectARB: prog.
	status := ogl glGetError.
	^(status = GLNoError)
! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/5/2007 09:26'!
mix1Factor
	"Answer the mix1Factor of the receiver"
	<bewareOf: #mix1FactorChanged>
	^self propertyValueAt: #mix1Factor! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/5/2007 09:26'!
mix1Factor: aValue
	"Modify the receiver's mix1Factor"
	^self propertyValueAt: #mix1Factor put: aValue with: #mix1FactorChanged! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/5/2007 09:26'!
mix2Factor
	"Answer the mix2Factor of the receiver"
	<bewareOf: #mix2FactorChanged>
	^self propertyValueAt: #mix2Factor! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/5/2007 09:26'!
mix2Factor: aValue
	"Modify the receiver's mix2Factor"
	^self propertyValueAt: #mix2Factor put: aValue with: #mix2FactorChanged! !

!MyOGLPlayer6 methodsFor: 'events' stamp: 'daf 8/4/2007 09:14'!
onPicked1Color1Changed
	<on: picked1Color1Changed>

	col1Factor1 := picked1Color1 asVectorColor asVector4.
! !

!MyOGLPlayer6 methodsFor: 'events' stamp: 'daf 8/4/2007 09:17'!
onPicked1Color2Changed
	<on: picked1Color2Changed>

	col2Factor1 := picked1Color2 asVectorColor asVector4.
! !

!MyOGLPlayer6 methodsFor: 'events' stamp: 'daf 8/4/2007 09:15'!
onPicked2Color1Changed
	<on: picked2Color1Changed>

	col1Factor2 := picked2Color1 asVectorColor asVector4.
! !

!MyOGLPlayer6 methodsFor: 'events' stamp: 'daf 8/4/2007 09:17'!
onPicked2Color2Changed
	<on: picked2Color2Changed>

	col2Factor2 := picked2Color2 asVectorColor asVector4.
! !

!MyOGLPlayer6 methodsFor: 'events' stamp: 'daf 8/4/2007 09:18'!
onSelect1FragChanged
	| |
	<on: select1FragChanged>

	curr1Frag := select1Frag.
	reloadFlag := true.
	Transcript show: curr1Frag printString;cr.! !

!MyOGLPlayer6 methodsFor: 'events' stamp: 'daf 8/4/2007 09:18'!
onSelect2FragChanged
	| |
	<on: select2FragChanged>

	curr2Frag := select2Frag.
	reloadFlag := true.
	Transcript show: curr2Frag printString;cr.! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
picked1Color1
	"Answer the picked1Color1 of the receiver"
	<bewareOf: #picked1Color1Changed>
	^self propertyValueAt: #picked1Color1! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
picked1Color1: aValue
	"Modify the receiver's picked1Color1"
	^self propertyValueAt: #picked1Color1 put: aValue with: #picked1Color1Changed! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
picked1Color2
	"Answer the picked1Color2 of the receiver"
	<bewareOf: #picked1Color2Changed>
	^self propertyValueAt: #picked1Color2! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
picked1Color2: aValue
	"Modify the receiver's picked1Color2"
	^self propertyValueAt: #picked1Color2 put: aValue with: #picked1Color2Changed! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
picked2Color1
	"Answer the picked2Color1 of the receiver"
	<bewareOf: #picked2Color1Changed>
	^self propertyValueAt: #picked2Color1! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
picked2Color1: aValue
	"Modify the receiver's picked2Color1"
	^self propertyValueAt: #picked2Color1 put: aValue with: #picked2Color1Changed! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
picked2Color2
	"Answer the picked2Color2 of the receiver"
	<bewareOf: #picked2Color2Changed>
	^self propertyValueAt: #picked2Color2! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
picked2Color2: aValue
	"Modify the receiver's picked2Color2"
	^self propertyValueAt: #picked2Color2 put: aValue with: #picked2Color2Changed! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/2/2007 21:17'!
prog
	"Answer the prog of the receiver"
	<bewareOf: #progChanged>
	^self propertyValueAt: #prog! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/2/2007 21:17'!
prog: aValue
	"Modify the receiver's prog"
	^self propertyValueAt: #prog put: aValue with: #progChanged! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/2/2007 21:17'!
reloadFlag
	"Answer the reloadFlag of the receiver"
	<bewareOf: #reloadFlagChanged>
	^self propertyValueAt: #reloadFlag! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/2/2007 21:17'!
reloadFlag: aValue
	"Modify the receiver's reloadFlag"
	^self propertyValueAt: #reloadFlag put: aValue with: #reloadFlagChanged! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
rot1Factor
	"Answer the rot1Factor of the receiver"
	<bewareOf: #rot1FactorChanged>
	^self propertyValueAt: #rot1Factor! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
rot1Factor: aValue
	"Modify the receiver's rot1Factor"
	^self propertyValueAt: #rot1Factor put: aValue with: #rot1FactorChanged! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
rot2Factor
	"Answer the rot2Factor of the receiver"
	<bewareOf: #rot2FactorChanged>
	^self propertyValueAt: #rot2Factor! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
rot2Factor: aValue
	"Modify the receiver's rot2Factor"
	^self propertyValueAt: #rot2Factor put: aValue with: #rot2FactorChanged! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/18/2007 09:31'!
saveFlag
	"Answer the saveFlag of the receiver"
	<bewareOf: #saveFlagChanged>
	^self propertyValueAt: #saveFlag! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/18/2007 09:31'!
saveFlag: aValue
	"Modify the receiver's saveFlag"
	^self propertyValueAt: #saveFlag put: aValue with: #saveFlagChanged! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/18/2007 10:09'!
savedForm
	"Answer the savedForm of the receiver"
	<bewareOf: #savedFormChanged>
	^self propertyValueAt: #savedForm! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/18/2007 10:09'!
savedForm: aValue
	"Modify the receiver's savedForm"
	^self propertyValueAt: #savedForm put: aValue with: #savedFormChanged! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
scale1Factor
	"Answer the scale1Factor of the receiver"
	<bewareOf: #scale1FactorChanged>
	^self propertyValueAt: #scale1Factor! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
scale1Factor: aValue
	"Modify the receiver's scale1Factor"
	^self propertyValueAt: #scale1Factor put: aValue with: #scale1FactorChanged! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
scale2Factor
	"Answer the scale2Factor of the receiver"
	<bewareOf: #scale2FactorChanged>
	^self propertyValueAt: #scale2Factor! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 08:03'!
scale2Factor: aValue
	"Modify the receiver's scale2Factor"
	^self propertyValueAt: #scale2Factor put: aValue with: #scale2FactorChanged! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 07:58'!
select1Frag
	"Answer the select1Frag of the receiver"
	<bewareOf: #select1FragChanged>
	^self propertyValueAt: #select1Frag! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 07:58'!
select1Frag: aValue
	"Modify the receiver's select1Frag"
	^self propertyValueAt: #select1Frag put: aValue with: #select1FragChanged! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 07:58'!
select2Frag
	"Answer the select2Frag of the receiver"
	<bewareOf: #select2FragChanged>
	^self propertyValueAt: #select2Frag! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/4/2007 07:58'!
select2Frag: aValue
	"Modify the receiver's select2Frag"
	^self propertyValueAt: #select2Frag put: aValue with: #select2FragChanged! !

!MyOGLPlayer6 methodsFor: 'accessing' stamp: 'daf 8/2/2007 21:17'!
selectors4Frags
	"Anwer a list of selectors that are fragment(pixel) shaders"
	"Note that this is entirely dependent on method/selector naming convention"

	| aList |
	aList := self class selectors select:
		[:aSelector | (aSelector beginsWith: 'frag')].

	^ aList asSortedArray! !

!MyOGLPlayer6 methodsFor: 'error handling' stamp: 'mtf 1/24/2011 14:33'!
showlog: anObj in: ogl
	"Get the OGL info log entry and show it."
	| length infoLog |

	length := IntegerArray new: 1.
	ogl glGetObjectParameterivARB: anObj with: GLObjectInfoLogLengthARB with: length.
	infoLog := ByteArray new: (length first).
	ogl glGetInfoLogARB: anObj with: (length first) with: nil with: infoLog.
	self handleError: (infoLog asString copyReplaceAll: ':' with: '\') withCRs.
! !

!MyOGLPlayer6 methodsFor: 'vertex shader' stamp: 'daf 8/2/2007 21:17'!
vertSource
^'	void main() {
		gl_Position = ftransform();
		gl_TexCoord[0]  = gl_MultiTexCoord0;
	}'
! !

Object subclass: #GPUInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'GLExtConstants OpenGLConstants'
	category: 'Tweak-OpenGL'!

!GPUInfo commentStamp: 'daf 7/15/2007 08:25' prior: 0!
A class to query some attributes of the video card GPU through the OpenGL drivers and show the results.!

!GPUInfo methodsFor: 'evaluating' stamp: 'daf 8/12/2007 14:47'!
chkGLSLSupport
	" GPUInfo new chkGLSLSupport. "
	"get some info from OpenGL drivers"
	| ogl ret extList |
	ogl := OpenGL newIn: (0@0 extent: 10@10).
	ret := WriteStream on: (String new: 600).
	[
		ret nextPutAll: 'OpenGL drivers'; cr.
		ret nextPutAll: 'version: '; nextPutAll: (self glGetString: GLVersion in: ogl); cr.
		ret nextPutAll: 'vendor: '; nextPutAll: (self glGetString: GLVendor in: ogl); cr.
		ret nextPutAll: 'renderer: '; nextPutAll: (self glGetString: GLRenderer in: ogl); cr.

		extList := ogl extensions.
		(extList includes: #'GL_ARB_shading_language_100') ifTrue: [
			ret nextPutAll: 'GLSL is supported, hurray!!'; cr.
		] ifFalse: [
			ret nextPutAll: 'GLSL is not supported, boo!!'; cr.
		].
		(extList includes: #'GL_ARB_vertex_shader') ifTrue: [
			ret nextPutAll: 'vertex shader is supported, hurray!!'; cr.
		] ifFalse: [
			ret nextPutAll: 'vertex shader is not supported, boo!!'; cr.
		].
		(extList includes: #'GL_ARB_fragment_shader') ifTrue: [
			ret nextPutAll: 'fragment shader is supported, hurray!!'; cr.
		] ifFalse: [
			ret nextPutAll: 'fragment shader is not supported, boo!!'; cr.
		].
		(extList includes: #'GL_EXT_framebuffer_object') ifTrue: [
			ret nextPutAll: 'FramebufferObject is supported, hurray!!'; cr.
		] ifFalse: [
			ret nextPutAll: 'FramebufferObject is not supported, boo!!'; cr.
		].
	] ensure: [ogl destroy].
	CDialog inform: ret contents.
! !

!GPUInfo methodsFor: 'evaluating' stamp: 'daf 7/28/2007 14:14'!
getAll
	" GPUInfo new getAll. "
	"get some info from OpenGL and GPU"
	| ogl ret |
	ogl := OpenGL newIn: (0@0 extent: 10@10).
	ret := WriteStream on: (String new: 600).
	[
		ret := self getAllFrom: ogl.
	] ensure: [ogl destroy].
	CDialog inform: ret contents! !

!GPUInfo methodsFor: 'evaluating' stamp: 'daf 8/12/2007 14:45'!
getAllFrom: ogl
	"get some info from OpenGL and GPU"
	| ret |
	ret := WriteStream on: (String new: 600).
	ret nextPutAll: 'version: '; nextPutAll: (self glGetString: GLVersion in: ogl); cr.
	ret nextPutAll: 'vendor: '; nextPutAll: (self glGetString: GLVendor in: ogl); cr.
	ret nextPutAll: 'renderer: '; nextPutAll: (self glGetString: GLRenderer in: ogl); cr.

	ret nextPutAll: 'tex units: '; nextPutAll: (self glGetInteger: GLMaxTextureUnitsArb in: ogl).
	ret nextPutAll: '  vertex attribs: '; nextPutAll: (self glGetInteger: GLMaxVertexAttribsARB in: ogl); cr.
	ret nextPutAll: 'tex coords: '; nextPutAll: (self glGetInteger: GLMaxTextureCoordsARB in: ogl).
	ret nextPutAll: '  tex image units: '; nextPutAll: (self glGetInteger: GLMaxTextureImageUnitsARB in: ogl); cr.

	ret nextPutAll: '* Vertex Programs | Fragment Programs'; cr.

	ret nextPutAll: 'max instructions: ';
		nextPutAll: (self glGetProgramI: GLVertexProgramARB with: GLMaxProgramInstructionsARB in: ogl);
		nextPutAll: ' | ';
		nextPutAll: (self glGetProgramI: GLFragmentProgramARB with: GLMaxProgramInstructionsARB in: ogl); cr. 

	ret nextPutAll: 'max temporaries: ';
		nextPutAll: (self glGetProgramI: GLVertexProgramARB with: GLMaxProgramTemporariesARB in: ogl);
		nextPutAll: ' | ';
		nextPutAll: (self glGetProgramI: GLFragmentProgramARB with: GLMaxProgramTemporariesARB in: ogl); cr. 

	ret nextPutAll: 'max Uniforms?: ';
		nextPutAll: (self glGetProgramI: GLVertexShaderARB with: GLMaxVertexUniformComponentsARB in: ogl);
		nextPutAll: ' | ';
		nextPutAll: (self glGetProgramI: GLFragmentShaderARB with: GLMaxFragmentUniformComponentsARB in: ogl); cr. 


"	ret nextPutAll: 'extensions: '.
	ogl extensions do: [ :ea | ret nextPutAll: ea ] separatedBy: [ ret nextPutAll: ', ' ]."
	^ ret contents! !

!GPUInfo methodsFor: 'accessing' stamp: 'daf 7/15/2007 10:25'!
glGetInteger: param in: ogl
	| value |
	value := IntegerArray new: 1.
	ogl glGetIntegerv: param with: value.
	^(value first) printString! !

!GPUInfo methodsFor: 'accessing' stamp: 'daf 7/15/2007 10:25'!
glGetProgramI: shader with: infoType in: ogl
	| value |
	value := IntegerArray new: 1.
	ogl glGetProgramivARB: shader with: infoType with: value.
	^(value first) printString! !

!GPUInfo methodsFor: 'accessing' stamp: 'daf 7/6/2007 07:59'!
glGetString: param in: ogl
	| value |
	value := ogl glGetString: param.
	^value fromCString
! !
